package rushhour.abstraction;

import java.util.List;

public interface IPlateau {
	/**
	 * Retourne le nombre de colonnes du plateau
	 * @return le nombre de colonnes du plateau
	 */
	public int getLargeur() ;
	/**
	 *  Retourne le nombre de lignes du plateau
	 * @return le nombre de lignes du plateau
	 */
	public int getHauteur() ;
	/**
	 *  Retourne la case correspondant a la sortie
	 * @return Retourne la case correspondant a la sortie
	 */
	public Case getSortie() ;
	/**
	 * Retourne une liste de IVehicule contenant l'ensemble des vehicules figurant sur le plateau
	 * @return une liste de IVehicule contenant l'ensemble des vehicules figurant sur le plateau
	 */
	public List<IVehicule> getVehicules() ;
	
	/**
	 * Retourne true si la case c est situee dans les limites du plateau
	 * @param c, une case quelconque
	 * @return true si la case c est situee dans les limites du plateau. Sinon, retourne false.
	 */
	public boolean contient(Case c) ;

	/**
	 * Retourne true si le vehicule rouge (le premier dans la liste de vehicule) occupe la case de la sortie.
	 * Sinon, retourne false.
	 * @return Retourne true si le vehicule rouge (le premier dans la liste de vehicule) occupe la case de la sortie. Sinon, retourne false.
	 */
	public boolean solutionTrouvee() ;
	/**
	 *  Retourne le IVehicule qui occupe la case c (retourne null si aucun vehicule n'occupe la case c).
	 * @param c, une case de l'aire de jeu
	 * @return  le IVehicule qui occupe la case c (retourne null si aucun vehicule n'occupe la case c).
	 */
	public IVehicule vehiculeEn(Case c);
}
