package rushhour.presentation;

import java.awt.*;

import javax.swing.*;

import rushhour.abstraction.Case;
import rushhour.abstraction.IPlateau;
import rushhour.abstraction.IVehicule;
//import rushhour.abstraction.Plateau;

import java.util.List;
import java.awt.event.*;
import java.awt.MediaTracker;
import java.io.*;

public class Embouteillage extends JPanel implements   MouseListener{  
	// CONSTANTES
	static final long serialVersionUID=1;
	private static final int BUFFER_DIM_H=3000; // dimensions de l'image servant au double buffering.
	private static final int BUFFER_DIM_V=2000; // dimensions de l'image servant au double buffering.
	public static final Color COULEUR_FOND = new Color(239,247,255); 

	public static final int PLATEAU_E        = 0 ;
	public static final int PLATEAU_N        = 1 ;
	public static final int PLATEAU_NE       = 2 ;
	public static final int PLATEAU_NO       = 3 ;
	public static final int PLATEAU_O        = 4 ;
	public static final int PLATEAU_OBSTACLE = 5 ;
	public static final int PLATEAU_S        = 6 ;
	public static final int PLATEAU_SE       = 7 ;
	public static final int PLATEAU_SO       = 8 ;
	public static final int PLATEAU_SORTIE_E = 9 ;
	public static final int PLATEAU_SORTIE_N = 10 ;
	public static final int PLATEAU_SORTIE_O = 11 ;
	public static final int PLATEAU_SORTIE_S = 12 ;
	public static final int PLATEAU_VIDE     = 13 ;
	public static final int VOITURE = 1;
	public static final int VOITURE_COLOREE = 2;
	public static final int NB_IMAGES_PLATEAU = 14;
	public static final int[] NB_IMAGES_VEHICULES = {0,0,2,3,1};
	public static final int NB_KLAXONS = 2; // POUR NE PAS VOUS FAIRE CHARGER DES FICHIERS TROP VOLUMINEUX, SEULS 2 BRUITS DE KLAXON SONT FOURNIS
	public static final int NB_APPLAUDISSEMENTS = 0;
	public static final int NB_COULEURS = 30;

	public static final int HORIZONTALE = 0;
	public static final int VERTICALE   = 1;

	// VARIABLES D'INSTANCE
	private MediaTracker tracker;
	private Image offscreen; 
	private Graphics bufferGraphics; 
	private ImageAjustee[] imagesPlateau;
	private Image[][][] imagesVehicules;
	private Image[][] vehicules;
	private boolean charge=false;

	private IPlateau plateau;
	private int colDepart, ligDepart;
	private int largeurAjustee;
	private boolean son;

	public Embouteillage(IPlateau plateau, boolean son) {
		this.son=son;
		this.plateau = plateau;
		this.setPreferredSize(new Dimension(800,600));
		this.setMinimumSize(new Dimension(800,600));
		this.setSize(new Dimension(800,600));
		imagesPlateau   = new ImageAjustee[ NB_IMAGES_PLATEAU ];
		imagesVehicules = new Image[5][4][60]; // longueur / orientation / couleur

		tracker = new MediaTracker( this );
		addMouseListener(this);
		if (this.son) {
			// POUR NE PAS VOUS FAIRE CHARGER DES FICHIERS TROP VOLUMINEUX, LA MUSIQUE D'AMBIANCE N'EST PAS CHARGEE
			//         new PlayerWav("bipbip.wav", true).start();
		}

	}
	public void chargerImages() {
		offscreen = createImage(BUFFER_DIM_H, BUFFER_DIM_V);//
		imagesPlateau[PLATEAU_E       ] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_E.gif"));
		imagesPlateau[PLATEAU_N       ] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_N.gif"));
		imagesPlateau[PLATEAU_NE      ] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_NE.gif"));
		imagesPlateau[PLATEAU_NO      ] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_NO.gif"));
		imagesPlateau[PLATEAU_O       ] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_O.gif"));
		imagesPlateau[PLATEAU_OBSTACLE] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_OBSTACLE.gif"));
		imagesPlateau[PLATEAU_S       ] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_S.gif"));
		imagesPlateau[PLATEAU_SE      ] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_SE.gif"));
		imagesPlateau[PLATEAU_SO      ] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_SO.gif"));
		imagesPlateau[PLATEAU_SORTIE_E] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_SORTIE_E.jpg"));//gif"));
		imagesPlateau[PLATEAU_SORTIE_N] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_SORTIE_N.jpg"));
		imagesPlateau[PLATEAU_SORTIE_O] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_SORTIE_O.jpg"));
		imagesPlateau[PLATEAU_SORTIE_S] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_SORTIE_S.jpg"));
		imagesPlateau[PLATEAU_VIDE    ] = new ImageAjustee( Toolkit.getDefaultToolkit().getImage("images"+File.separator+"PLATEAU_VIDE.gif"));

		vehicules = new Image[5][];
		for (int i=0; i<5; i++) {
			vehicules[i]=new Image[NB_IMAGES_VEHICULES[i]];
			for (int j=0; j<NB_IMAGES_VEHICULES[i]; j++) {
				vehicules[i][j] =Toolkit.getDefaultToolkit().getImage("images"+File.separator+"VEHICULE_"+i+"_"+j+".gif");
				tracker.addImage(vehicules[i][j] , 0);
			}
		}
		tracker.addImage(offscreen, 0);
		tracker.addImage(imagesPlateau[PLATEAU_E].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_N].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_NE].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_NO].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_O].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_OBSTACLE].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_S].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_SE].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_SO].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_SORTIE_E].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_SORTIE_N].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_SORTIE_O].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_SORTIE_S].getImage(), 0);
		tracker.addImage(imagesPlateau[PLATEAU_VIDE].getImage(), 0);

		try {
			tracker.waitForID(0);
		} catch (InterruptedException e) {
			System.out.println("erreur tracker "+e);
		}
		if (offscreen==null || offscreen.getWidth(null)<0 || imagesPlateau[PLATEAU_VIDE].getWidthInit()<0 || vehicules[2][0].getWidth(null)<0) {
			System.out.println("probleme lors du chargement des images");
			this.charge=false;
		}
		else {
			System.out.println("images correctement chargees");
			this.charge=true;
		}
		if (imagesPlateau[PLATEAU_VIDE].getWidthInit()!=imagesPlateau[PLATEAU_VIDE].getHeightInit()
				||imagesPlateau[PLATEAU_E].getWidthInit()!=imagesPlateau[PLATEAU_E].getHeightInit()   
				||imagesPlateau[PLATEAU_N].getWidthInit()!=imagesPlateau[PLATEAU_N].getHeightInit()   
				||imagesPlateau[PLATEAU_NE].getWidthInit()!=imagesPlateau[PLATEAU_NE].getHeightInit()   
				||imagesPlateau[PLATEAU_NO].getWidthInit()!=imagesPlateau[PLATEAU_NO].getHeightInit()   
				||imagesPlateau[PLATEAU_O].getWidthInit()!=imagesPlateau[PLATEAU_O].getHeightInit()   
				||imagesPlateau[PLATEAU_OBSTACLE].getWidthInit()!=imagesPlateau[PLATEAU_OBSTACLE].getHeightInit()   
				||imagesPlateau[PLATEAU_S].getWidthInit()!=imagesPlateau[PLATEAU_S].getHeightInit()   
				||imagesPlateau[PLATEAU_SE].getWidthInit()!=imagesPlateau[PLATEAU_SE].getHeightInit()   
				||imagesPlateau[PLATEAU_SO].getWidthInit()!=imagesPlateau[PLATEAU_SO].getHeightInit()   
				||imagesPlateau[PLATEAU_SORTIE_E].getWidthInit()!=imagesPlateau[PLATEAU_SORTIE_E].getHeightInit()   
				||imagesPlateau[PLATEAU_SORTIE_N].getWidthInit()!=imagesPlateau[PLATEAU_SORTIE_N].getHeightInit()   
				||imagesPlateau[PLATEAU_SORTIE_O].getWidthInit()!=imagesPlateau[PLATEAU_SORTIE_O].getHeightInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_SORTIE_S].getHeightInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_SORTIE_O].getWidthInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_SORTIE_N].getWidthInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_SORTIE_E].getWidthInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_SO].getWidthInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_SE].getWidthInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_S].getWidthInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_OBSTACLE].getWidthInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_O].getWidthInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_NO].getWidthInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_NE].getWidthInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_N].getWidthInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_E].getWidthInit()   
				||imagesPlateau[PLATEAU_SORTIE_S].getWidthInit()!=imagesPlateau[PLATEAU_VIDE].getWidthInit()   
				) {
			System.out.println("Les images composant le plateau doivent etre des carres de meme dimension");
			System.exit(0);
		} 
		for (int lg=0; lg<5; lg++) {
			for (int j=0; j<NB_IMAGES_VEHICULES[lg]; j++) {
				if (vehicules[lg][j].getWidth(null)!=lg*imagesPlateau[PLATEAU_VIDE].getWidthInit()
						||vehicules[lg][j].getHeight(null)!=imagesPlateau[PLATEAU_VIDE].getHeightInit()) {
					System.out.println("l'image VEHICULE_"+lg+"_"+j+".gif doit etre de meme hauteur qu'une case du plateau et d'une largeur correspondant a "+lg+" cases du plateau. Elle a actuellement une largeur de "+vehicules[lg][j].getWidth(null)+" et une hauteur de "+vehicules[lg][j].getHeight(null));
				}

			}
		}
	}

	public ImageAjustee creerVehicule(int longueur, boolean orient, int couleur, String inscription) {
		int orientation=0;
		if (orient==IVehicule.VERTICALE) {
			orientation=1;
		}
		if (imagesVehicules[longueur][orientation][couleur]==null) {
			Color c; 
			int rouge, vert, bleu, rougeFonce, bleuFonce, vertFonce, rougeClair, vertClair, bleuClair;
			int[][][] cl, cl2;
			int num = (int)(Math.random()*NB_IMAGES_VEHICULES[longueur]);
			cl= Images.couleursPixels(vehicules[longueur][num]);
			if (orientation==HORIZONTALE) {
				cl2 = new int[cl.length][cl[0].length][cl[0][0].length];                    
			}
			else {
				cl2 = new int[cl[0].length][cl.length][cl[0][0].length];
			}
			if (couleur<(NB_COULEURS-20)) {
				c= Color.getHSBColor((float)((float)couleur/(10)), .99f, .70f); //0.75f*
				rouge=c.getRed();
				bleu = c.getBlue();
				vert = c.getGreen();
				c= Color.getHSBColor((float)((float)couleur/(10)), .99f, .50f);
				rougeFonce=c.getRed();
				bleuFonce = c.getBlue();
				vertFonce = c.getGreen();
				c= Color.getHSBColor((float)((float)couleur/(10)), .99f, .95f);
				rougeClair=c.getRed();
				bleuClair = c.getBlue();
				vertClair = c.getGreen();
			}
			else {
				if (couleur<(NB_COULEURS-10)) {
					c= Color.getHSBColor((float)((float)(couleur-10)/(10)), .35f, .70f); 
					rouge=c.getRed();
					bleu = c.getBlue();
					vert = c.getGreen();
					c= Color.getHSBColor((float)((float)(couleur-10)/(10)), .35f, .50f);
					rougeFonce=c.getRed();
					bleuFonce = c.getBlue();
					vertFonce = c.getGreen();
					c= Color.getHSBColor((float)((float)(couleur-10)/(10)), .35f, .95f);
					rougeClair=c.getRed();
					bleuClair = c.getBlue();
					vertClair = c.getGreen();
				}
				else {
					rouge = 20*(couleur-(NB_COULEURS-10))+25;
					vert  = 20*(couleur-(NB_COULEURS-10))+25;
					bleu  = 20*(couleur-(NB_COULEURS-10))+25;
					rougeFonce = 20*(couleur-(NB_COULEURS-10));
					vertFonce  = 20*(couleur-(NB_COULEURS-10));
					bleuFonce  = 20*(couleur-(NB_COULEURS-10));
					rougeClair = 20*(couleur-(NB_COULEURS-10))+50;
					vertClair  = 20*(couleur-(NB_COULEURS-10))+50;
					bleuClair  = 20*(couleur-(NB_COULEURS-10))+50;
				}
			}
			for (int i=0; i<cl.length; i++) {
				for (int j=0; j<cl[i].length; j++) {
					int r = cl[i][j][1];
					int v = cl[i][j][2];
					int b = cl[i][j][3];
					int rr = r;
					int vv = v; 
					int bb = b; 
					if (r==0 && v==0 && b==255) {
						charge=true;
						rr=rouge;
						vv=vert;
						bb=bleu;
					}
					if (r==0 && v==0 && b==132) {
						charge=true;
						rr=rougeFonce;
						vv=vertFonce;
						bb=bleuFonce;
					}
					if (r==132 && v==132 && b==255) {
						charge=true;
						rr=rougeClair;
						vv=vertClair;
						bb=bleuClair;
					}
					if (orientation==HORIZONTALE) {
						cl2[i][j][0]=255;
						cl2[i][j][1]=rr;
						cl2[i][j][2]=vv;
						cl2[i][j][3]=bb;
					}
					else {
						cl2[j][cl2[0].length-1-i][0]=255; 
						cl2[j][cl2[0].length-1-i][1]=rr;
						cl2[j][cl2[0].length-1-i][2]=vv;
						cl2[j][cl2[0].length-1-i][3]=bb;
					}
				}
			}
			imagesVehicules[longueur][orientation][couleur] = Images.image(cl2);
			tracker.addImage( imagesVehicules[longueur][orientation][couleur], 0);

			try {
				tracker.waitForID(0);
			} catch (InterruptedException e) {
				System.out.println("erreur tracker "+e);
			}

		}
		return new ImageAjustee( imagesVehicules[longueur][orientation][couleur], inscription );    
	}

	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		if (!this.charge) {
			System.out.println("chargement des images...");
			chargerImages();
		}

		bufferGraphics = offscreen.getGraphics(); 
		bufferGraphics.setColor(COULEUR_FOND);
		bufferGraphics.fillRect(0,0,BUFFER_DIM_H, BUFFER_DIM_V);
		int largeurDalle = imagesPlateau[PLATEAU_VIDE].getWidthInit();
		int hauteurDalle = imagesPlateau[PLATEAU_VIDE].getHeightInit();
		int largeurPanel =  this.getSize().width;
		int hauteurPanel =  this.getSize().height;
		double ratioHorizontal =((double)largeurPanel)/((2+this.plateau.getLargeur())*largeurDalle);
		double ratioVertical =((double)hauteurPanel)/((2+this.plateau.getHauteur())*hauteurDalle);
		double ratio = Math.min(ratioHorizontal, ratioVertical);
		ImageAjustee.setRatio(ratio);

		this.largeurAjustee = this.imagesPlateau[PLATEAU_VIDE].getWidth();

		for (int i=0; i<this.plateau.getLargeur(); i++) {
			imagesPlateau[PLATEAU_N].afficher(bufferGraphics, (i+1)*largeurAjustee, 0, this);
			imagesPlateau[PLATEAU_S].afficher(bufferGraphics, (i+1)*largeurAjustee, (this.plateau.getHauteur()+1)*largeurAjustee, this);
		}
		for (int i=0; i<this.plateau.getHauteur(); i++) {
			imagesPlateau[PLATEAU_O].afficher(bufferGraphics, 0, (i+1)*largeurAjustee, this);
			imagesPlateau[PLATEAU_E].afficher(bufferGraphics, (this.plateau.getLargeur()+1)*largeurAjustee,(i+1)*largeurAjustee,  this);
		}
		for (int i=0; i<this.plateau.getLargeur(); i++) {
			for (int j=0; j<this.plateau.getHauteur();j++) {
				imagesPlateau[PLATEAU_VIDE].afficher(bufferGraphics, (i+1)*largeurAjustee, (j+1)*largeurAjustee, this);
			}
		}
		imagesPlateau[PLATEAU_NO].afficher(bufferGraphics, 0,0, this);
		imagesPlateau[PLATEAU_NE].afficher(bufferGraphics, (this.plateau.getLargeur()+1)*largeurAjustee, 0, this);
		imagesPlateau[PLATEAU_SO].afficher(bufferGraphics, 0, (this.plateau.getHauteur()+1)*largeurAjustee, this);
		imagesPlateau[PLATEAU_SE].afficher(bufferGraphics, (this.plateau.getLargeur()+1)*largeurAjustee, (this.plateau.getHauteur()+1)*largeurAjustee, this);
		if (this.plateau.getSortie().getLig()==0) { // la sortie est sur le bord nord
			imagesPlateau[PLATEAU_SORTIE_N].afficher(bufferGraphics, (this.plateau.getSortie().getCol()+1)*largeurAjustee,0, this);
		}
		else {
			if (this.plateau.getSortie().getCol()==0) { // la sortie est sur le bord ouest
				imagesPlateau[PLATEAU_SORTIE_O].afficher(bufferGraphics, 0, (this.plateau.getSortie().getLig()+1)*largeurAjustee, this);
			}
			else {
				if (this.plateau.getSortie().getLig()>=this.plateau.getHauteur()-1) { // la sortie est sur le bord sud
					imagesPlateau[PLATEAU_SORTIE_S].afficher(bufferGraphics, (this.plateau.getSortie().getCol()+1)*largeurAjustee,(1+this.plateau.getHauteur())*largeurAjustee, this);
				}
				else {
					if (this.plateau.getSortie().getLig()>=this.plateau.getHauteur()-1) { // la sortie est sur le bord sud
						imagesPlateau[PLATEAU_SORTIE_S].afficher(bufferGraphics, (this.plateau.getSortie().getCol()+1)*largeurAjustee,(1+this.plateau.getHauteur())*largeurAjustee, this);
					}
					else {
						imagesPlateau[PLATEAU_SORTIE_E].afficher(bufferGraphics, (1+this.plateau.getLargeur())*largeurAjustee,(this.plateau.getSortie().getLig()+1)*largeurAjustee, this);
					}
				}
			}
		}
		//  Vehicule[] vehicules = this.plateau.getVehicules();
		List<IVehicule> vehicules = this.plateau.getVehicules();
		for (int i=0; i<vehicules.size();i++) {
			creerVehicule(vehicules.get(i).getLongueur(),vehicules.get(i).getOrientation(), vehicules.get(i).getCouleur(),vehicules.get(i).getInscription() ) .afficher(bufferGraphics, (1+vehicules.get(i).getCases().get(0).getCol())*largeurAjustee,(1+vehicules.get(i).getCases().get(0).getLig())*largeurAjustee, this);
		}
		g.drawImage(offscreen,0, 0,this);
	}

	public void    mousePressed(MouseEvent e) {
		this.colDepart=(e.getX()/this.largeurAjustee)-1;
		this.ligDepart=(e.getY()/this.largeurAjustee)-1;
	}
	public void mouseReleased(MouseEvent e) {

		int colArrivee =(e.getX()/this.largeurAjustee)-1;
		int ligArrivee =(e.getY()/this.largeurAjustee)-1;
		if (this.plateau.contient(new Case(colDepart, ligDepart)) && this.plateau.contient(new Case(colArrivee, ligArrivee)) ) {
			boolean possible = false;
			int deltaCol = colArrivee-colDepart;
			int deltaLig = ligArrivee-ligDepart;
			IVehicule vehicule = this.plateau.vehiculeEn(new Case(colDepart, ligDepart));
			if (vehicule!=null &&((deltaCol==0 && vehicule.getOrientation()==IVehicule.VERTICALE)
					|| (deltaLig==0 && vehicule.getOrientation()==IVehicule.HORIZONTALE))) {

				boolean cheminLibre = true;
				if (deltaCol<0) {
					int depart = vehicule.getCases().get(0).getCol()-1;
					int arrivee = depart+deltaCol+1;
					int lig = vehicule.getCases().get(0).getLig();
					int col=depart;
					while (cheminLibre && col>=arrivee) {

						cheminLibre = this.plateau.vehiculeEn(new Case(col, lig))==null; 
						col--;
					}
					if (cheminLibre && this.plateau.contient(new Case(arrivee, lig)) &&  this.plateau.contient(new Case(arrivee+vehicule.getLongueur()-1, lig))) {
						possible=true;
						vehicule.deplacerEn(new Case(arrivee, lig));                	   
					}
				} else {
					if (deltaCol>0) {
						int depart = vehicule.getCases().get(vehicule.getLongueur()-1).getCol()+1;
						int arrivee = depart+deltaCol-1;
						int lig = vehicule.getCases().get(0).getLig();
						int col=depart;
						while (cheminLibre && col<=arrivee) {

							cheminLibre = this.plateau.vehiculeEn(new Case(col, lig))==null; 
							col++;
						}
						if (cheminLibre&& this.plateau.contient(new Case(vehicule.getCases().get(0).getCol()+deltaCol, lig)) &&  this.plateau.contient(new Case(vehicule.getCases().get(0).getCol()+deltaCol+vehicule.getLongueur()-1, lig))) {
							possible=true;
							vehicule.deplacerEn(new Case(vehicule.getCases().get(0).getCol()+deltaCol, lig));                	   
						}
					} else {
						if (deltaLig<0) {
							int depart = vehicule.getCases().get(0).getLig()-1;
							int arrivee = depart+deltaLig+1;
							int lig = depart;
							int col=vehicule.getCases().get(0).getCol();
							while (cheminLibre && lig>=arrivee) {
								cheminLibre = this.plateau.vehiculeEn(new Case(col, lig))==null; 
								lig--;
							}
							if (cheminLibre && this.plateau.contient(new Case(col, arrivee)) &&  this.plateau.contient(new Case(col, arrivee+vehicule.getLongueur()-1))) {
								possible=true;
								vehicule.deplacerEn(new Case(col, arrivee));                	   
							}
						} else {

							int depart = vehicule.getCases().get(vehicule.getLongueur()-1).getLig()+1;
							int arrivee = depart+deltaLig-1;
							int lig = depart;
							int col=vehicule.getCases().get(0).getCol();
							while (cheminLibre && lig<=arrivee) {
								cheminLibre = this.plateau.vehiculeEn(new Case(col, lig))==null; 
								lig++;
							}
							if (cheminLibre&& this.plateau.contient(new Case(col, vehicule.getCases().get(0).getLig()+deltaLig)) &&  this.plateau.contient(new Case(col, vehicule.getCases().get(0).getLig()+deltaLig+vehicule.getLongueur()-1))) {
								possible=true;
								vehicule.deplacerEn(new Case(col, vehicule.getCases().get(0).getLig()+deltaLig));                	   
							}

						}
					}
				}
				if (!possible) {
					int fichier = (int)(Math.random()*NB_KLAXONS);
					new PlayerWav("sons"+File.separator+"klaxon"+fichier+".wav", false).start();
				}
			}
			/*
      if (this.colDepart>=0 && this.ligDepart>=0 
            && this.colDepart<this.plateau.getLargeur() && this.ligDepart<this.plateau.getHauteur()
            && colArrivee<=this.plateau.getLargeur() && ligArrivee<=this.plateau.getHauteur()
            && (this.colDepart!=colArrivee || this.ligDepart!=ligArrivee)) {
         if (!this.plateau.deplacement(this.colDepart, this.ligDepart, colArrivee, ligArrivee)) {
            if (this.son) {
               int fichier = (int)(Math.random()*NB_KLAXONS);

               new PlayerWav("sons"+File.separator+"klaxon"+fichier+".wav", false).start();
            }
         }

	}*/
			this.repaint();
			if (this.plateau.solutionTrouvee()) {
				if (this.son){
					// POUR NE PAS VOUS FAIRE CHARGER DES FICHIERS TROP VOLUMINEUX, LES APPLAUDISSEMENTS NE SONT PAS JOUES
					//   int fichier = (int)(Math.random()*NB_APPLAUDISSEMENTS);
					//   new PlayerWav("applaudissements"+fichier+".wav", false).start();
				}

				JOptionPane.showMessageDialog(this,"Bravo !!! Vous avez gagne !!! Cliquez sur [OK] pour fermer le programme","Bravo",JOptionPane.INFORMATION_MESSAGE);

				System.out.println("gagne !!! bravo !!!");
				System.exit(0);
			}
		}
	}
	public void    mouseClicked(MouseEvent e) {}
	public void    mouseEntered(MouseEvent e) {}
	public void    mouseExited(MouseEvent e) {}
}
