package rushhour.presentation;
// ---------------------------------------------
// Nom    : DEBRUYNE
// Prenom : Romuald
// ---------------------------------------------
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.ImageObserver;


public class ImageAjustee{
   private Image img;
   private static double ratio;
   private String inscription; 
   private static int maxFontSize=60;
   private static int minFontSize=6;
   private static int fontSize=-1;
   
   public ImageAjustee(Image img) {
      this.setImage(img);
      this.setInscription(null);
   }
   public ImageAjustee(Image img, String ins) {
      this(img);
      this.setInscription(ins);
   }
   public String getInscription() {
      return this.inscription;
   }
   public Image getImage() {
      return this.img;
   }
   public void setImage(Image i){
      this.img = i;
   }
   public void setInscription(String ins) {
      this.inscription=ins;
   }
   public static void setRatio(double ratio) {
      ImageAjustee.ratio = ratio;
   }
   public static void setMaxFontSize(int s) {
      ImageAjustee.maxFontSize=s;
   }
   public static int getMaxFontSize() {
      return ImageAjustee.maxFontSize;
   }
   public static void setMinFontSize(int s) {
      ImageAjustee.minFontSize=s;
   }
   public static int getMinFontSize() {
      return ImageAjustee.minFontSize;
   }
   public static void setFontSize(int s) {
      ImageAjustee.fontSize=s;
   }
   public static int getFontSize() {
      return ImageAjustee.fontSize;
   }
   public void afficher(Graphics g, int x, int y, ImageObserver i) {
      g.drawImage( this.getImage(), x, y, this.getWidth(), this.getHeight(), i);
      if (this.getInscription()!=null) {
         int size=ImageAjustee.getMaxFontSize();
         int largeur, hauteur;
         int dim = Math.min(this.getWidth(), this.getHeight())-10;
         if (ImageAjustee.getFontSize()<0) {
            do {
               Font f=new Font("arial", Font.BOLD, size );
               g.setFont(f);
               largeur = (int) g.getFontMetrics().getStringBounds(this.getInscription(), g).getBounds().getWidth();
               hauteur = (int) (g.getFontMetrics().getStringBounds(this.getInscription(), g).getBounds().getHeight());
               size--;
            } while (size>=ImageAjustee.getMinFontSize() && (largeur>dim || hauteur>dim));
         } 
         else {
            size=ImageAjustee.getFontSize();
            Font f=new Font("arial", Font.BOLD, size );
            g.setFont(f);
            largeur = (int) g.getFontMetrics().getStringBounds(this.getInscription(), g).getBounds().getWidth();
            hauteur = (int)(g.getFontMetrics().getStringBounds(this.getInscription(), g).getBounds().getHeight());
         }
         if (size>=ImageAjustee.getMinFontSize()) {
            hauteur=(int)(0.65*hauteur);
            int dx=(this.getWidth()-largeur)/2;
            int dy=(this.getHeight()-hauteur)/2;
            g.setColor(Color.WHITE);
            g.drawString(this.getInscription(), x+dx, y+dy+hauteur);
         }
      }
   }
   public int getWidthInit() {
      return this.getImage().getWidth(null);
   }
   public int getWidth() {
      return (int)(this.getWidthInit()*ImageAjustee.ratio);
   }
   public int getHeightInit() {
      return this.getImage().getHeight(null);
   }
   public int getHeight() {
      return (int)(this.getHeightInit()*ImageAjustee.ratio);
   }
}
