package rushhour.presentation;
// ---------------------------------------------
// Nom    : Debruyne
// Prenom : Romuald
// ---------------------------------------------

import java.awt.Container;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.image.BufferedImage;
import java.awt.image.MemoryImageSource; 
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JApplet;




@SuppressWarnings("removal")
public class Images extends JApplet {
//=================================
    public static final long serialVersionUID=1l;
    private static final int MASK = 0xFF;
     
    public static int[][][] chargerBMPCouleur( String nomFichier) {
    //-------------------------------------------------
       return couleursPixels(chargerBMP( nomFichier ));
    }
    
    public static int[][] chargerBMPGris( String nomFichier) {
    //-------------------------------------------------
       return niveauGris(chargerBMPCouleur( nomFichier ));
    }

    public static int[][][] chargerJPGCouleur( String nomFichier) {
    //-------------------------------------------------
       Images instanceBidon = new Images();
       Image photo = instanceBidon.getToolkit().getImage(nomFichier); 
       
       return couleursPixels(photo);
    }

    public static int[][] chargerJPGGris( String nomFichier) {
    //-------------------------------------------------
       return niveauGris(chargerJPGCouleur(nomFichier));
    }

    public static void enregistrerJPGCouleur( int[][][] p, String nomFichier) {
    //----------------------------------------------------------------
       enregistrerJPGCouleur( image( p ), nomFichier);
    }

    public static void enregistrerJPGGris( int[][] p, String nomFichier) {
    //----------------------------------------------------------------
       enregistrerJPGCouleur( couleur(p) , nomFichier);
    }

    public static  void enregistrerBMPCouleur( int[][][] p, String nomFichier) {
    //----------------------------------------------------------------
       enregistrerBMP( toBufferedImage(image( p )), nomFichier);
    }

    public static void enregistrerBMPGris( int[][] p, String nomFichier) {
    //----------------------------------------------------------------
       enregistrerBMPCouleur( couleur(p) , nomFichier);
    }

    public static int[][] reduireTaille(int[][] t, int largeur, int hauteur) {
    //----------------------------------------------------------------------
       int[][] aRetourner=new int[largeur][hauteur];
       int xMin, xMax, yMin, yMax, l, h, moy;
       l=t.length;
       h=t[0].length;
       for (int x=0; x<largeur; x++) {
          xMin=(x*l)/largeur;
          xMax=Math.min(l,((x+1)*l)/largeur);
          for (int y=0; y<hauteur; y++) {
             yMin=(y*h)/hauteur;
             yMax=Math.min(h, ((y+1)*h)/hauteur);
             moy=0;
             for (int x2=xMin; x2<xMax; x2++) {
                for (int y2=yMin; y2<yMax; y2++) {
                   moy+=t[x2][y2];
                }
             }
             moy=moy/((xMax-xMin)*(yMax-yMin));
             aRetourner[x][y]=moy;
          }
       }
       return aRetourner;
    }

//------------------
// METHODES INTERNES
//------------------
    private static int[][] niveauGris(int[][][] i) {
    //--------------------------------------------
       int[][] t=new int[i.length][i[0].length];
       for (int x=0; x<i.length; x++) {
          for (int y=0; y<i[0].length; y++) {
             t[x][y]=(i[x][y][1]+i[x][y][2]+i[x][y][3])/3;
          }
       }
       return t;
    }

    private static int[][][] couleur(int[][] i) {
    //-----------------------------------------
       int[][][] t=new int[i.length][i[0].length][4];
       for (int x=0; x<i.length; x++) {
          for (int y=0; y<i[0].length; y++) {
             t[x][y][0]=255;
             t[x][y][1]=i[x][y];
             t[x][y][2]=i[x][y];
             t[x][y][3]=i[x][y];
          }
       }
       return t;
    }

    public static Image chargerBMP(String nomFichier) {
    //----------------------------------------
    //Entree : un chemin indiquant l'emplacement de l'image au format BMP a ouvrir
    //Sortie : une instance d'Image correspondant au contenu du fichier
       File fichier = new File(nomFichier);
       try {
          DataInputStream inBMP = new DataInputStream(new FileInputStream(fichier));
          inBMP.skipBytes(18); // partie inutile de l'en-tete
          int width = lireInt(inBMP); // lecture de la largeur
          int height = lireInt(inBMP); // lecture de la hauteur
          inBMP.skipBytes(28); // partie inutile de l'en-tete
   
          BufferedImage img = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
          int sup = (width * 3) % 4;
          for(int y = height - 1; y >= 0; y--) {
             for(int x = 0; x < width; x++) {
                img.setRGB(x, y, lireColor(inBMP));
             }
             inBMP.skipBytes(sup); // bourrage
          }
          inBMP.close();
          return img;
       }
       catch(Exception e){
          return null;
       }
    }

    private static void enregistrerBMP(BufferedImage img, String nomFichier) {
    //----------------------------------------------------------------
    //Entree : un chemin indiquant l'emplacement et le nom du fichier a creer
    //Sortie : enregistre l'image img dans le fichier de nom nomFichier
       try{
          DataOutputStream outBMP = new DataOutputStream(new FileOutputStream(nomFichier));
          int resx = img.getWidth();
          int resy = img.getHeight();
          // en-tete du fichier
          outBMP.write(0x42);
          outBMP.write(0x4D);
          ecrireInt(outBMP,resx*resy*3+54);
          ecrireInt(outBMP,0); 
          ecrireInt(outBMP,54);
          ecrireInt(outBMP,40);
          ecrireInt(outBMP,resx); 
          ecrireInt(outBMP,resy);
          outBMP.write(0);
          outBMP.write(0);
          outBMP.write(24);
          outBMP.write(0);
          ecrireInt(outBMP,0);
          ecrireInt(outBMP,resx*resy*3);
          ecrireInt(outBMP,2851);
          ecrireInt(outBMP,2851);
          ecrireInt(outBMP,0);
          ecrireInt(outBMP,0);
          int sup = (resx * 3) % 4;
          for (int y = resy - 1; y >= 0; y--) {
             for (int x = 0; x < resx; x++) {
                ecrireColor(outBMP, img.getRGB(x, y));
             }
             for (int j = 0; j < sup; j++) { // bourrage
                outBMP.writeByte(0);
             }
          }
          outBMP.close();
       }
       catch(Exception e){
       }
    }

    private static void enregistrerJPGCouleur(Image image, String nomFichier) {
    //---------------------------------------------------------------
       File f = new File(nomFichier);
       try {
          ImageIO.write(toBufferedImage(image),"jpeg",f);
       } catch (Exception e) {}
    }

    private static BufferedImage toBufferedImage(Image image) {  
    //-------------------------------------------------------
       if(image instanceof BufferedImage) { // si c'est deja une BufferedImage il n'y a rien a faire
          return((BufferedImage)image);
       }
       else {
          image = new ImageIcon(image).getImage();
          BufferedImage bufferedImage = new BufferedImage(image.getWidth(null),image.getHeight(null),BufferedImage.TYPE_INT_RGB );
          Graphics g = bufferedImage.createGraphics();
          g.drawImage(image,0,0,null);
          g.dispose();
          return(bufferedImage);
       }
    }

    private static int getHauteur(Image image) {   
    //---------------------------------
       MediaTracker mt=new MediaTracker(new Container());
       mt.addImage(image,0);
       try {
          mt.waitForID(0); 
       } catch(InterruptedException ie){}
       return image.getHeight(null);
    }  

    private static int getLargeur(Image image) {   
    //---------------------------------
       MediaTracker mt=new MediaTracker(new Container());
       mt.addImage(image,0);
       try {
          mt.waitForID(0); 
       } catch(InterruptedException ie){}
       return image.getWidth(null);
    }  

    public static int[][][] couleursPixels(Image image) { 
    //-------------------------------------------
       BufferedImage bi=toBufferedImage(image);
       int largeur=getLargeur(image); int hauteur=getHauteur(image);
       int[][][]t=new int[largeur][hauteur][4];
       for (int x=0;x<largeur;x++) {
          for (int y=0;y<hauteur;y++) {
             int rgb = bi.getRGB(x,y);
             t[x][y][0]=((rgb >>24 ) & 0xFF);// alpha
             t[x][y][1]=((rgb >>16 ) & 0xFF);// rouge
             t[x][y][2]=((rgb >>8 ) & 0xFF); // vert
             t[x][y][3]=(rgb & 0xFF);        // bleu
          }
       }
       return t;
    }

    public static Image image(int[][][]t) { 
    //-----------------------------
       int largeur=t.length;
       int hauteur=t[0].length;
       int[]tSortie=new int[largeur*hauteur];
       for (int y=0; y<hauteur; y++) {
          for (int x=0; x<largeur; x++) {
             tSortie[y*largeur+x]=(t[x][y][0]<<24)+(t[x][y][1]<<16)+(t[x][y][2]<<8)+(t[x][y][3]);
          }
       }
       Images instanceBidon = new Images();
       Image imagesortie=instanceBidon.createImage(new MemoryImageSource(largeur, hauteur, tSortie,0,largeur));
       return imagesortie;
    }
   
    private static int lireInt(DataInputStream in) {
    //--------------------------------------------
    //Methode interne permettant de lire un entier dans un DataInputStream
       byte[] b = new byte[4];
       int aRetourner = 0;
       try {
          in.read(b);
          aRetourner = b[0] & MASK;
          aRetourner = aRetourner + ((b[1] & MASK) << 8);
          aRetourner = aRetourner + ((b[2] & MASK) << 16);
          aRetourner = aRetourner + ((b[3] & MASK) << 24);
       }
       catch(Exception e){
       }
       return aRetourner;
    }
    
    private static int lireColor(DataInputStream in) {
    //----------------------------------------------
    //Methode interne permettant de lire une couleur dans un DataInputStream
       byte[] b = new byte[3];
       int aRetourner = 0;
       try {
          in.read(b);         
          aRetourner = b[0] & MASK;
          aRetourner = aRetourner + ((b[1] & MASK) << 8);
          aRetourner = aRetourner + ((b[2] & MASK) << 16);
       }
       catch(Exception e){
       }
       return aRetourner;
    }

    private static void ecrireInt(DataOutputStream sortie, int n) {
    //-----------------------------------------------------------
    // Methode interne permettant d'ecrire un entier dans un DataOutputStream
       try {
          sortie.write((n) & MASK);
          sortie.write((n>>8) & MASK);
          sortie.write((n>>16) & MASK);
          sortie.write((n>>24) & MASK);
       }
       catch (Exception e) {
       }
    }
    
    private static void ecrireColor(DataOutputStream sortie, int couleur) {
    //-------------------------------------------------------------------
    // Methode interne permettant d'ecrire un entier dans un DataOutputStream
       try {
          sortie.write((couleur) & MASK);
          sortie.write((couleur>>8) & MASK);
          sortie.write((couleur>>16) & MASK);
       }
       catch (Exception e) {
       }
    }
 }
