package rushhour.presentation;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Point;
import java.awt.Toolkit;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JFrame;

import rushhour.abstraction.Case;
import rushhour.abstraction.IPlateau;
import rushhour.abstraction.IVehicule;
import rushhour.abstraction.Plateau;
import rushhour.abstraction.Vehicule;

public class Starter extends JFrame {
   // CONSTANTES
   public final static long serialVersionUID = 1l;
   public final static boolean SONS_ON = true;
   public final static boolean SONS_OFF = false;

   // VARIABLE D'INSTANCE
   private Embouteillage e;

   // CONSTRUCTEUR
   public Starter(){
      super("Rush Hour");
      this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      this.setLayout(new BorderLayout());

      String nomFic;
      File f ; 
      int largeur = 0; 
      int hauteur = 0;
      int colSortie = 0;
      int ligSortie = 0;
      int nbVehicules = 0;
      int longueur=0;
      int col = 0;
      int lig = 0;
      boolean orientation = false;
      int couleur = 0;
      String nom;
      
      do {
         System.out.println("Quelle carte voulez-vous charger ?");
         nomFic = Clavier.lireString();
         f = new File( nomFic );
         if (!f.exists()) {
            System.out.println("ce fichier n'existe pas");
         }
      } while (nomFic.equals("") || !f.exists());

      List<IVehicule> vehicules = new ArrayList<IVehicule>();
      try { 
         BufferedReader aLire= new BufferedReader(new FileReader(nomFic));

         largeur = Integer.parseInt(aLire.readLine());
         hauteur = Integer.parseInt(aLire.readLine());
         colSortie = Integer.parseInt(aLire.readLine());
         ligSortie = Integer.parseInt(aLire.readLine());
         nbVehicules = Integer.parseInt(aLire.readLine());
         
         for (int i=0; i<nbVehicules; i++) {
            longueur = Integer.parseInt(aLire.readLine());
            orientation = Boolean.parseBoolean(aLire.readLine());
            col = Integer.parseInt(aLire.readLine());
            lig = Integer.parseInt(aLire.readLine());
            couleur = Integer.parseInt(aLire.readLine());
            nom = aLire.readLine();
            vehicules.add(new Vehicule(longueur, orientation, new Case(col, lig), couleur, nom)); 
         }
         aLire.close( );
      }  catch (IOException e) { 
         System.out.println("Une operation sur les fichiers a leve l'exception "+e);
      }
      
      IPlateau p = new Plateau(largeur, hauteur, new Case(colSortie, ligSortie), vehicules);

      e = new Embouteillage(p,SONS_ON);

      add(e,BorderLayout.CENTER);
      pack();
      setVisible(true);
      Cursor curseur = Toolkit.getDefaultToolkit().createCustomCursor(Toolkit.getDefaultToolkit().getImage("images"+File.separator+"DOIGT.gif"), new Point( 0,0 ), "" );
      setCursor(curseur );
   }
   
   public static void main(String[] args) {
      new Starter();
   }
}
