package rushhour.tests.tools;

import java.io.File;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

import rushhour.abstraction.Case;
import rushhour.abstraction.IVehicule;




public class TestsS04 {


	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test01VehiculeConstructeur() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.Vehicule");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe Vehicule. Impossible de tester");
			return 0;
		}

		Field fieldLongueur=null,  fieldCouleur=null, fieldOrientation=null, fieldCase=null, fieldInscription=null, fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//Final(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLongueur==null && (f.getName().toLowerCase().contains("n")||f.getName().toLowerCase().contains("z")||fieldCouleur!=null)) {
						fieldLongueur=f;
					} else if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldOrientation==null && f.getType().equals(boolean.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldOrientation = f;
				} else if (fieldCase==null && f.getType().equals(Case.class)) {
					fieldCase=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}
		if (fieldLongueur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la longueur du vehicule.");
			return 0;
		}
		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldOrientation==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance booleenne correspondant a l'orientation du vehicule.");
			return 0;
		}
		if (fieldCase==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case la plus en haut a gauche du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=5) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 5 variables d'instance mentionnees dans l'enonce");
			return 0;
		}
		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe Vehicule n'implemente pas l'interface IVehicule.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldLongueur.getModifiers())
				|| !Modifier.isPrivate(fieldCouleur.getModifiers())
				|| !Modifier.isPrivate(fieldCase.getModifiers())
				|| !Modifier.isPrivate(fieldInscription.getModifiers())
				|| !Modifier.isPrivate(fieldOrientation.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Vehicule(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
		fieldLongueur.setAccessible(true);
		fieldOrientation.setAccessible(true);
		fieldCase.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(0,0), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,2), Integer.valueOf(96), new String("D")},
		};

		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			int resLongueur=0;
			boolean resOrientation=false;
			Case resCase=null;
			int resCouleur = 0;
			String resInscription="";
			try {
				pt1 = (c2.newInstance(ints[i]));
				resLongueur = (int)(fieldLongueur.get(pt1));
				resOrientation = (boolean)(fieldOrientation.get(pt1));
				resCase = (Case)(fieldCase.get(pt1));
				resCouleur = (int)(fieldCouleur.get(pt1));
				resInscription = (String)(fieldInscription.get(pt1));
			} catch (Exception e) {
				e.printStackTrace();
			}
			if (resLongueur!=(int)(ints[i][0])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v a pour longueur "+resLongueur+".\n");
				return 0;
			}
			if (resOrientation!=(boolean)(ints[i][1])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v a pour orientation "+resOrientation+".\n");
				return 0;
			}
			if (resCase!=(Case)(ints[i][2])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v a pour case "+resCase+".\n");
				return 0;
			}
			if (resCouleur!=(int)(ints[i][3])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v a pour couleur "+resCouleur+".\n");
				return 0;
			}
			if (!resInscription.equals((String)(ints[i][4]))) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v a pour inscription "+resInscription+".\n");
				return 0;
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}



	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test02VehiculeAccesseurs() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.Vehicule");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe Vehicule. Impossible de tester");
			return 0;
		}

		Field fieldLongueur=null,  fieldCouleur=null, fieldOrientation=null, fieldCase=null, fieldInscription=null, fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLongueur==null && (f.getName().toLowerCase().contains("n")||f.getName().toLowerCase().contains("z")||fieldCouleur!=null)) {
						fieldLongueur=f;
					} else if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldOrientation==null && f.getType().equals(boolean.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldOrientation = f;
				} else if (fieldCase==null && f.getType().equals(Case.class)) {
					fieldCase=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}
		if (fieldLongueur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la longueur du vehicule.");
			return 0;
		}
		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldOrientation==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance booleenne correspondant a l'orientation du vehicule.");
			return 0;
		}
		if (fieldCase==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case la plus en haut a gauche du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=5) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 5 variables d'instance mentionnees dans l'enonce");
			return 0;
		}
		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe Vehicule n'implemente pas l'interface IVehicule.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldLongueur.getModifiers())
				|| !Modifier.isPrivate(fieldCouleur.getModifiers())
				|| !Modifier.isPrivate(fieldCase.getModifiers())
				|| !Modifier.isPrivate(fieldInscription.getModifiers())
				|| !Modifier.isPrivate(fieldOrientation.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Vehicule(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
		fieldLongueur.setAccessible(true);
		fieldOrientation.setAccessible(true);
		fieldCase.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		Method mGetLongueur=null;
		Method mGetOrientation=null;
		//Method mGetHautGauche=null;
		Method mGetCases=null;
		Method mGetCouleur=null;
		Method mGetInscription=null;
		Class[] ar = {};
		try {
			mGetLongueur = cVehicule.getDeclaredMethod("getLongueur", ar);
			mGetOrientation = cVehicule.getDeclaredMethod("getOrientation", ar);
			//	mGetHautGauche = cVehicule.getDeclaredMethod("getHautGauche", ar);
			mGetCases = cVehicule.getDeclaredMethod("getCases", ar);
			mGetCouleur = cVehicule.getDeclaredMethod("getCouleur", ar);
			mGetInscription = cVehicule.getDeclaredMethod("getInscription", ar);
		} catch (NoSuchMethodException e1) {
			e1.printStackTrace();
		} catch (SecurityException e1) {
			e1.printStackTrace();
		}
		if (mGetLongueur==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getLongueur() dans Vehicule");
			return 0;
		}
		if (mGetOrientation==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getOrientation() dans Vehicule");
			return 0;
		}

		if (mGetCases==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getCases() dans Vehicule");
			return 0;
		}
		if (mGetCouleur==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getCouleur() dans Vehicule");
			return 0;
		}
		if (mGetInscription==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getInscription() dans Vehicule");
			return 0;
		}

		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(0,0), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,2), Integer.valueOf(96), new String("D")},
		};
		Case[][] cases = {
				{new Case(0,0), new Case(1,0)},
				{new Case(2,4), new Case(3,4), new Case(4,4)},
				{new Case(1,3), new Case(1,4)},
				{new Case(3,2), new Case(3,3), new Case(3,4)}
		};
		Object[] arg = {};
		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			int resLongueur=0;
			boolean resOrientation=false;
			//Case resCase=null;
			List<Case> resCases=null;
			int resCouleur = 0;
			String resInscription="";
			try {
				pt1 = (c2.newInstance(ints[i]));
				fieldLongueur.set(pt1,  ints[i][0]);
				fieldOrientation.set(pt1,  ints[i][1]);
				fieldCase.set(pt1,  ints[i][2]);
				fieldCouleur.set(pt1,  ints[i][3]);
				fieldInscription.set(pt1,  ints[i][4]);
				resLongueur = (int)(mGetLongueur.invoke(pt1,  arg));
				resOrientation = (boolean)(mGetOrientation.invoke(pt1,  arg));
				//		resCase = (Case)(mGetHautGauche.invoke(pt1,  arg));
				resCouleur = (int)(mGetCouleur.invoke(pt1,  arg));
				resInscription = (String)(mGetInscription.invoke(pt1,  arg));
				resCases = (List<Case>)(mGetCases.invoke(pt1, arg));
			} catch (Exception e) {
				e.printStackTrace();
			}
			if (resLongueur!=(int)(ints[i][0])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v.getLongueur() retourne "+resLongueur+".\n");
				return 0;
			}
			if (resOrientation!=(boolean)(ints[i][1])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v.getOrientation() "+resOrientation+".\n");
				return 0;
			}
			/*	if (resCase!=(Case)(ints[i][2])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v.getHautGauche() retourne "+resCase+".\n");
				return 0;
			}*/
			if (resCouleur!=(int)(ints[i][3])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v.getCouleur() retourne "+resCouleur+".\n");
				return 0;
			}
			if (!resInscription.equals((String)(ints[i][4]))) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v.getInscription() retourne "+resInscription+".\n");
				return 0;
			}
			if (!resCases.equals(Arrays.asList(cases[i]))) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v.getCases() retourne "+resCases+" au lieu de "+Arrays.asList(cases[i]));
				return 0;
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}




	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test03VehiculeDeplacerEn() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.Vehicule");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe Vehicule. Impossible de tester");
			return 0;
		}

		Field fieldLongueur=null,  fieldCouleur=null, fieldOrientation=null, fieldCase=null, fieldInscription=null, fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLongueur==null && (f.getName().toLowerCase().contains("n")||f.getName().toLowerCase().contains("z")||fieldCouleur!=null)) {
						fieldLongueur=f;
					} else if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldOrientation==null && f.getType().equals(boolean.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldOrientation = f;
				} else if (fieldCase==null && f.getType().equals(Case.class)) {
					fieldCase=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}
		if (fieldLongueur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la longueur du vehicule.");
			return 0;
		}
		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldOrientation==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance booleenne correspondant a l'orientation du vehicule.");
			return 0;
		}
		if (fieldCase==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case la plus en haut a gauche du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=5) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 5 variables d'instance mentionnees dans l'enonce");
			return 0;
		}
		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe Vehicule n'implemente pas l'interface IVehicule.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldLongueur.getModifiers())
				|| !Modifier.isPrivate(fieldCouleur.getModifiers())
				|| !Modifier.isPrivate(fieldCase.getModifiers())
				|| !Modifier.isPrivate(fieldInscription.getModifiers())
				|| !Modifier.isPrivate(fieldOrientation.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Vehicule(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
		fieldLongueur.setAccessible(true);
		fieldOrientation.setAccessible(true);
		fieldCase.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		Method mDeplacerEn=null;
		Class[] ar = {Case.class};
		try {
			mDeplacerEn = cVehicule.getDeclaredMethod("deplacerEn", ar);
		} catch (NoSuchMethodException e1) {
			e1.printStackTrace();
		} catch (SecurityException e1) {
			e1.printStackTrace();
		}
		if (mDeplacerEn==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode deplacerEn(Case) dans Vehicule");
			return 0;
		}

		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(0,0), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,2), Integer.valueOf(96), new String("D")},
		};
		Case[][] cases = {
				{new Case(3,2)},
				{new Case(1,2)},
				{new Case(2,1)},
				{new Case(3,1)}
		};
		Object[] arg = new Object[1];

		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			//int resLongueur=0;
			//boolean resOrientation=false;
			Case resCase=null;
			//List<Case> resCases=null;
			//int resCouleur = 0;
			//String resInscription="";
			try {
				pt1 = (c2.newInstance(ints[i]));
				fieldLongueur.set(pt1,  ints[i][0]);
				fieldOrientation.set(pt1,  ints[i][1]);
				fieldCase.set(pt1,  ints[i][2]);
				fieldCouleur.set(pt1,  ints[i][3]);
				fieldInscription.set(pt1,  ints[i][4]);
				arg[0]=cases[i][0];
				mDeplacerEn.invoke(pt1,  arg);
				resCase=(Case)(fieldCase.get(pt1)); 
			} catch (Exception e) {
				e.printStackTrace();
			}
			if (!resCase.equals(cases[i][0])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") et v.deplaceEn("+cases[i][0]+") la case haut gauche du vehicule est "+resCase+".\n");
				return 0;
			} 
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}





	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test04VehiculeOccupe() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.Vehicule");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe Vehicule. Impossible de tester");
			return 0;
		}

		Field fieldLongueur=null,  fieldCouleur=null, fieldOrientation=null, fieldCase=null, fieldInscription=null, fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLongueur==null && (f.getName().toLowerCase().contains("n")||f.getName().toLowerCase().contains("z")||fieldCouleur!=null)) {
						fieldLongueur=f;
					} else if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldOrientation==null && f.getType().equals(boolean.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldOrientation = f;
				} else if (fieldCase==null && f.getType().equals(Case.class)) {
					fieldCase=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}
		if (fieldLongueur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la longueur du vehicule.");
			return 0;
		}
		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldOrientation==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance booleenne correspondant a l'orientation du vehicule.");
			return 0;
		}
		if (fieldCase==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case la plus en haut a gauche du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=5) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 5 variables d'instance mentionnees dans l'enonce");
			return 0;
		}
		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe Vehicule n'implemente pas l'interface IVehicule.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldLongueur.getModifiers())
				|| !Modifier.isPrivate(fieldCouleur.getModifiers())
				|| !Modifier.isPrivate(fieldCase.getModifiers())
				|| !Modifier.isPrivate(fieldInscription.getModifiers())
				|| !Modifier.isPrivate(fieldOrientation.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Vehicule(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
		fieldLongueur.setAccessible(true);
		fieldOrientation.setAccessible(true);
		fieldCase.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		Method mOccupe=null;
		Class[] ar = {Case.class};
		try {
			mOccupe = cVehicule.getDeclaredMethod("occupe", ar);
		} catch (NoSuchMethodException e1) {
			e1.printStackTrace();
		} catch (SecurityException e1) {
			e1.printStackTrace();
		}
		if (mOccupe==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode occupe(Case) dans Vehicule");
			return 0;
		}

		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(0,0), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,2), Integer.valueOf(96), new String("D")},
		};
		Case[][] cases = {
				{new Case(0,0), new Case(1,0), new Case(0,1), new Case(1,1)},
				{new Case(2,4), new Case(3,4), new Case(4,4), new Case(1,4), new Case(2,3), new Case(2,5), new Case(5,4), new Case(4,3), new Case(4,5)},
				{new Case(1,3), new Case(1,4), new Case(1,2), new Case(0,3), new Case(2,3), new Case(1,5), new Case(0,4), new Case(2,2)},
				{new Case(3,2), new Case(3,3), new Case(3,4), new Case(3,1), new Case(2,2), new Case(4,2), new Case(3,5), new Case(2,4), new Case(4,4)}
		};
		boolean[][] res = {
				{true, true, false, false},
				{true, true, true, false, false, false, false, false, false},
				{true, true, false, false, false, false, false, false},
				{true, true, true, false, false, false, false, false, false}
		};
		Object[] arg = new Object[1];

		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			//int resLongueur=0;
			//boolean resOrientation=false;
//			Case resCase=null;
//			List<Case> resCases=null;
//			int resCouleur = 0;
//			String resInscription="";
			boolean resOccupe=false;
			try {
				pt1 = (c2.newInstance(ints[i]));
				fieldLongueur.set(pt1,  ints[i][0]);
				fieldOrientation.set(pt1,  ints[i][1]);
				fieldCase.set(pt1,  ints[i][2]);
				fieldCouleur.set(pt1,  ints[i][3]);
				fieldInscription.set(pt1,  ints[i][4]);
				for (int jj=0; jj<cases[i].length; jj++) {
					arg[0]=cases[i][jj];
					resOccupe = (boolean)(mOccupe.invoke(pt1,  arg));
					if (resOccupe!=res[i][jj]) {
						System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+")  v.occupe("+cases[i][jj]+") retourne "+resOccupe+".\n");
						return 0;
					} 
				}
			//	resCase=(Case)(fieldCase.get(pt1)); 
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}





	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test05PlateauConstructeur() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cIPlateau = Reflexion.getClass("rushhour.abstraction.IPlateau");
		if (cIPlateau==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IPlateau dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.Vehicule");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe Vehicule. Impossible de tester");
			return 0;
		}
		Class cPlateau= Reflexion.getClass("rushhour.abstraction.Plateau");
		if (cPlateau==null) {
			System.out.println("   Aie... je ne trouve pas la classe Plateau. Impossible de tester");
			return 0;
		}

		Field fieldLongueur=null,  fieldCouleur=null, fieldOrientation=null, fieldCase=null, fieldInscription=null, fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLongueur==null && (f.getName().toLowerCase().contains("n")||f.getName().toLowerCase().contains("z")||fieldCouleur!=null)) {
						fieldLongueur=f;
					} else if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldOrientation==null && f.getType().equals(boolean.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldOrientation = f;
				} else if (fieldCase==null && f.getType().equals(Case.class)) {
					fieldCase=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}
		if (fieldLongueur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la longueur du vehicule.");
			return 0;
		}
		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldOrientation==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance booleenne correspondant a l'orientation du vehicule.");
			return 0;
		}
		if (fieldCase==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case la plus en haut a gauche du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=5) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 5 variables d'instance mentionnees dans l'enonce");
			return 0;
		}


		Field fieldLargeur=null,  fieldHauteur=null, fieldSortie=null, fieldVehicules=null;// fieldOther=null;
		Field[] tfp = cPlateau.getDeclaredFields();
		int nbvp=0;
		for (Field f : tfp) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbvp++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLargeur==null && (f.getName().toLowerCase().contains("la")||fieldHauteur!=null)) {
						fieldLargeur=f;
					} else if (fieldHauteur==null) {
						fieldHauteur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldSortie==null && f.getType().equals(Case.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldSortie = f;
				} else if (fieldVehicules==null &&( f.getType().equals(List.class)|| f.getType().equals(ArrayList.class)|| f.getType().equals(LinkedList.class))) {
					fieldVehicules=f;
				} else {
					System.out.println("typee="+f.getType()+"<<<");
					fieldOther = f;
				}
			}
		}
		if (fieldLargeur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la largeur du plateau.");
			return 0;
		}
		if (fieldHauteur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la hauteur du plateau.");
			return 0;
		}
		if (fieldSortie==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case de sortie du plateau.");
			return 0;
		}
		if (fieldVehicules==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type List<IVehicule> correspondant a la liste des vehicules du plateau.");
			return 0;
		}
		if (fieldOther!=null || nbvp!=4) {
			System.out.println("   Aie... Votre classe Plateau devrait comporter uniquement les 4 variables d'instance mentionnees dans l'enonce");
			return 0;
		}

		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe Vehicule n'implemente pas l'interface IVehicule.");
			return 0;
		}

		if (!Reflexion.implementsInterface(cPlateau, cIPlateau)) {
			System.out.println("   Aie... La classe Plateau n'implemente pas l'interface IPlateau.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldLargeur.getModifiers())
				|| !Modifier.isPrivate(fieldHauteur.getModifiers())
				|| !Modifier.isPrivate(fieldSortie.getModifiers())
				|| !Modifier.isPrivate(fieldVehicules.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Vehicule(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
		Class[] arg3 = { int.class, int.class, Case.class, List.class };
		Constructor c3=null;
		try {
			c3 = cPlateau.getDeclaredConstructor(arg3);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c3=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c3==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Plateau(int, int, Case, List<IVehicule>). Impossible de tester");
			return 0;
		}
		fieldLongueur.setAccessible(true);
		fieldOrientation.setAccessible(true);
		fieldCase.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		fieldLargeur.setAccessible(true);
		fieldHauteur.setAccessible(true);
		fieldSortie.setAccessible(true);
		fieldVehicules.setAccessible(true);
		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(0,0), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,2), Integer.valueOf(96), new String("D")},
		};
		Object[][] pp = {
				{10, 8, new Case(0,4), new ArrayList<IVehicule>()},
				{8, 10, new Case(4,0), new ArrayList<IVehicule>()},
				{12, 6, new Case(5,11), new ArrayList<IVehicule>()},
				{16, 12, new Case(15,5), new ArrayList<IVehicule>()},

		};
		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			Object pt2=null;
			int resLargeur=0;
			int resHauteur=0;
			Case resCase=null;
			List<IVehicule> resVehicules = null;
			//String resInscription="";
			List<IVehicule> l = new ArrayList<IVehicule>();
			try {
				pt1 = (c2.newInstance(ints[i]));
				l.add((IVehicule)pt1);
				pp[i][3]=l;
				pt2 = (c3.newInstance(pp[i]));
				resLargeur = (int)(fieldLargeur.get(pt2));
				resHauteur = (int)(fieldHauteur.get(pt2));
				resCase = (Case)(fieldSortie.get(pt2));
				resVehicules = (List<IVehicule>)(fieldVehicules.get(pt2));
				//	resInscription = (String)(fieldInscription.get(pt1));
			} catch (Exception e) {
				e.printStackTrace();
			}
			if (resLargeur!=(int)(pp[i][0])) {
				System.out.println("   Aie... apres p = new Plateau( "+pp[i][0]+", "+pp[i][1]+", "+pp[i][2]+", "+pp[i][3]+") p a pour largeur "+resLargeur+".\n");
				return 0;
			}
			if (resHauteur!=(int)(pp[i][1])) {
				System.out.println("   Aie... apres p = new Plateau( "+pp[i][0]+", "+pp[i][1]+", "+pp[i][2]+", "+pp[i][3]+") p a pour hauteur "+resHauteur+".\n");
				return 0;
			}
			if (!resCase.equals((Case)(pp[i][2]))) {
				System.out.println("   Aie... apres p = new Plateau( "+pp[i][0]+", "+pp[i][1]+", "+pp[i][2]+", "+pp[i][3]+") p a pour sortie "+resCase+".\n");
				return 0;
			}
			if (!resVehicules.equals(l)) {
				System.out.println("   Aie... apres p = new Plateau( "+pp[i][0]+", "+pp[i][1]+", "+pp[i][2]+", "+pp[i][3]+") p a pour liste de vehicules "+resVehicules+".\n");
				return 0;
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}





	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test06PlateauAccesseurs() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cIPlateau = Reflexion.getClass("rushhour.abstraction.IPlateau");
		if (cIPlateau==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IPlateau dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.Vehicule");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe Vehicule. Impossible de tester");
			return 0;
		}
		Class cPlateau= Reflexion.getClass("rushhour.abstraction.Plateau");
		if (cPlateau==null) {
			System.out.println("   Aie... je ne trouve pas la classe Plateau. Impossible de tester");
			return 0;
		}

		Field fieldLongueur=null,  fieldCouleur=null, fieldOrientation=null, fieldCase=null, fieldInscription=null, fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLongueur==null && (f.getName().toLowerCase().contains("n")||f.getName().toLowerCase().contains("z")||fieldCouleur!=null)) {
						fieldLongueur=f;
					} else if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldOrientation==null && f.getType().equals(boolean.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldOrientation = f;
				} else if (fieldCase==null && f.getType().equals(Case.class)) {
					fieldCase=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}
		if (fieldLongueur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la longueur du vehicule.");
			return 0;
		}
		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldOrientation==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance booleenne correspondant a l'orientation du vehicule.");
			return 0;
		}
		if (fieldCase==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case la plus en haut a gauche du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=5) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 5 variables d'instance mentionnees dans l'enonce");
			return 0;
		}


		Field fieldLargeur=null,  fieldHauteur=null, fieldSortie=null, fieldVehicules=null;// fieldOther=null;
		Field[] tfp = cPlateau.getDeclaredFields();
		int nbvp=0;
		for (Field f : tfp) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbvp++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLargeur==null && (f.getName().toLowerCase().contains("la")||fieldHauteur!=null)) {
						fieldLargeur=f;
					} else if (fieldHauteur==null) {
						fieldHauteur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldSortie==null && f.getType().equals(Case.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldSortie = f;
				} else if (fieldVehicules==null &&( f.getType().equals(List.class)|| f.getType().equals(ArrayList.class)|| f.getType().equals(LinkedList.class))) {
					fieldVehicules=f;
				} else {
					System.out.println("typee="+f.getType()+"<<<");
					fieldOther = f;
				}
			}
		}
		if (fieldLargeur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la largeur du plateau.");
			return 0;
		}
		if (fieldHauteur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la hauteur du plateau.");
			return 0;
		}
		if (fieldSortie==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case de sortie du plateau.");
			return 0;
		}
		if (fieldVehicules==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type List<IVehicule> correspondant a la liste des vehicules du plateau.");
			return 0;
		}
		if (fieldOther!=null || nbvp!=4) {
			System.out.println("   Aie... Votre classe Plateau devrait comporter uniquement les 4 variables d'instance mentionnees dans l'enonce");
			return 0;
		}

		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe Vehicule n'implemente pas l'interface IVehicule.");
			return 0;
		}

		if (!Reflexion.implementsInterface(cPlateau, cIPlateau)) {
			System.out.println("   Aie... La classe Plateau n'implemente pas l'interface IPlateau.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldLargeur.getModifiers())
				|| !Modifier.isPrivate(fieldHauteur.getModifiers())
				|| !Modifier.isPrivate(fieldSortie.getModifiers())
				|| !Modifier.isPrivate(fieldVehicules.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Vehicule(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
		Class[] arg3 = { int.class, int.class, Case.class, List.class };
		//	Class[] arg4 = { int.class, int.class, Case.class, ArrayList.class };
		//	Class[] arg5 = { int.class, int.class, Case.class, LinkedList.class };
		Constructor c3=null;
		try {
			c3 = cPlateau.getDeclaredConstructor(arg3);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c3=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c3==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Plateau(int, int, Case, List<IVehicule>). Impossible de tester");
			return 0;
		}
		fieldLongueur.setAccessible(true);
		fieldOrientation.setAccessible(true);
		fieldCase.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		fieldLargeur.setAccessible(true);
		fieldHauteur.setAccessible(true);
		fieldSortie.setAccessible(true);
		fieldVehicules.setAccessible(true);
		Method mGetLargeur=null;
		Method mGetHauteur=null;
		Method mGetSortie=null;
		Method mGetVehicules=null;

		Class[] ar = {};
		try {
			mGetLargeur = cPlateau.getDeclaredMethod("getLargeur", ar);
			mGetHauteur = cPlateau.getDeclaredMethod("getHauteur", ar);
			//	mGetHautGauche = cVehicule.getDeclaredMethod("getHautGauche", ar);
			mGetSortie = cPlateau.getDeclaredMethod("getSortie", ar);
			mGetVehicules = cPlateau.getDeclaredMethod("getVehicules", ar);
		} catch (NoSuchMethodException e1) {
			e1.printStackTrace();
		} catch (SecurityException e1) {
			e1.printStackTrace();
		}
		if (mGetLargeur==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getLargeur() dans Plateau");
			return 0;
		}
		if (mGetHauteur==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getHauteur() dans Plateau");
			return 0;
		}
		if (mGetSortie==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getSortie() dans Plateau");
			return 0;
		}
		if (mGetVehicules==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getVehicules() dans Plateau");
			return 0;
		}

		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(0,0), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,2), Integer.valueOf(96), new String("D")},
		};
		Object[][] pp = {
				{10, 8, new Case(0,4), new ArrayList<IVehicule>()},
				{8, 10, new Case(4,0), new ArrayList<IVehicule>()},
				{12, 6, new Case(5,11), new ArrayList<IVehicule>()},
				{16, 12, new Case(15,5), new ArrayList<IVehicule>()},

		};
		Object[]argVide = {};
		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			Object pt2=null;
			int resLargeur=0;
			int resHauteur=0;
			Case resCase=null;
			List<IVehicule> resVehicules = null;
			List<IVehicule> l = new ArrayList<IVehicule>();
			try {
				pt1 = (c2.newInstance(ints[i]));
				l.add((IVehicule)pt1);
				pp[i][3]=l;
				pt2 = (c3.newInstance(pp[i]));
			//	resLargeur = (int)(fieldLargeur.get(pt2));
			//	resHauteur = (int)(fieldHauteur.get(pt2));
			//	resCase = (Case)(fieldSortie.get(pt2));
			//	resVehicules = (List<IVehicule>)(fieldVehicules.get(pt2));
				
				
				
				resLargeur = (int)(mGetLargeur.invoke(pt2,  argVide));
				resHauteur = (int)(mGetHauteur.invoke(pt2,  argVide));
				resCase = (Case)(mGetSortie.invoke(pt2,  argVide));
				resVehicules = (List<IVehicule>)(mGetVehicules.invoke(pt2,  argVide));
			
				
			} catch (Exception e) {
				e.printStackTrace();
			}
			if (resLargeur!=(int)(pp[i][0])) {
				System.out.println("   Aie... apres p = new Plateau( "+pp[i][0]+", "+pp[i][1]+", "+pp[i][2]+", "+pp[i][3]+") p a pour largeur "+resLargeur+".\n");
				return 0;
			}
			if (resHauteur!=(int)(pp[i][1])) {
				System.out.println("   Aie... apres p = new Plateau( "+pp[i][0]+", "+pp[i][1]+", "+pp[i][2]+", "+pp[i][3]+") p a pour hauteur "+resHauteur+".\n");
				return 0;
			}
			if (!resCase.equals((Case)(pp[i][2]))) {
				System.out.println("   Aie... apres p = new Plateau( "+pp[i][0]+", "+pp[i][1]+", "+pp[i][2]+", "+pp[i][3]+") p a pour sortie "+resCase+".\n");
				return 0;
			}
			if (!resVehicules.equals(l)) {
				System.out.println("   Aie... apres p = new Plateau( "+pp[i][0]+", "+pp[i][1]+", "+pp[i][2]+", "+pp[i][3]+") p a pour liste de vehicules "+resVehicules+".\n");
				return 0;
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}







	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test07PlateauContient() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cIPlateau = Reflexion.getClass("rushhour.abstraction.IPlateau");
		if (cIPlateau==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IPlateau dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.Vehicule");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe Vehicule. Impossible de tester");
			return 0;
		}
		Class cPlateau= Reflexion.getClass("rushhour.abstraction.Plateau");
		if (cPlateau==null) {
			System.out.println("   Aie... je ne trouve pas la classe Plateau. Impossible de tester");
			return 0;
		}

		Field fieldLongueur=null,  fieldCouleur=null, fieldOrientation=null, fieldCase=null, fieldInscription=null, fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLongueur==null && (f.getName().toLowerCase().contains("n")||f.getName().toLowerCase().contains("z")||fieldCouleur!=null)) {
						fieldLongueur=f;
					} else if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldOrientation==null && f.getType().equals(boolean.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldOrientation = f;
				} else if (fieldCase==null && f.getType().equals(Case.class)) {
					fieldCase=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}
		if (fieldLongueur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la longueur du vehicule.");
			return 0;
		}
		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldOrientation==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance booleenne correspondant a l'orientation du vehicule.");
			return 0;
		}
		if (fieldCase==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case la plus en haut a gauche du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=5) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 5 variables d'instance mentionnees dans l'enonce");
			return 0;
		}


		Field fieldLargeur=null,  fieldHauteur=null, fieldSortie=null, fieldVehicules=null;// fieldOther=null;
		Field[] tfp = cPlateau.getDeclaredFields();
		int nbvp=0;
		for (Field f : tfp) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbvp++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLargeur==null && (f.getName().toLowerCase().contains("la")||fieldHauteur!=null)) {
						fieldLargeur=f;
					} else if (fieldHauteur==null) {
						fieldHauteur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldSortie==null && f.getType().equals(Case.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldSortie = f;
				} else if (fieldVehicules==null &&( f.getType().equals(List.class)|| f.getType().equals(ArrayList.class)|| f.getType().equals(LinkedList.class))) {
					fieldVehicules=f;
				} else {
					System.out.println("typee="+f.getType()+"<<<");
					fieldOther = f;
				}
			}
		}
		if (fieldLargeur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la largeur du plateau.");
			return 0;
		}
		if (fieldHauteur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la hauteur du plateau.");
			return 0;
		}
		if (fieldSortie==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case de sortie du plateau.");
			return 0;
		}
		if (fieldVehicules==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type List<IVehicule> correspondant a la liste des vehicules du plateau.");
			return 0;
		}
		if (fieldOther!=null || nbvp!=4) {
			System.out.println("   Aie... Votre classe Plateau devrait comporter uniquement les 4 variables d'instance mentionnees dans l'enonce");
			return 0;
		}

		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe Vehicule n'implemente pas l'interface IVehicule.");
			return 0;
		}

		if (!Reflexion.implementsInterface(cPlateau, cIPlateau)) {
			System.out.println("   Aie... La classe Plateau n'implemente pas l'interface IPlateau.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldLargeur.getModifiers())
				|| !Modifier.isPrivate(fieldHauteur.getModifiers())
				|| !Modifier.isPrivate(fieldSortie.getModifiers())
				|| !Modifier.isPrivate(fieldVehicules.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Vehicule(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
		Class[] arg3 = { int.class, int.class, Case.class, List.class };
		Constructor c3=null;
		try {
			c3 = cPlateau.getDeclaredConstructor(arg3);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c3=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c3==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Plateau(int, int, Case, List<IVehicule>). Impossible de tester");
			return 0;
		}
		fieldLongueur.setAccessible(true);
		fieldOrientation.setAccessible(true);
		fieldCase.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		fieldLargeur.setAccessible(true);
		fieldHauteur.setAccessible(true);
		fieldSortie.setAccessible(true);
		fieldVehicules.setAccessible(true);
		Method mContient=null;

		Class[] ar = {Case.class};
		try {
			mContient = cPlateau.getDeclaredMethod("contient", ar);
		} catch (NoSuchMethodException e1) {
			e1.printStackTrace();
		} catch (SecurityException e1) {
			e1.printStackTrace();
		}
		if (mContient==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode contient(Case) dans Plateau");
			return 0;
		}

		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(0,0), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,2), Integer.valueOf(96), new String("D")},
		};
		Object[][] pp = {
				{10, 8, new Case(0,4), new ArrayList<IVehicule>()},
				{8, 10, new Case(4,0), new ArrayList<IVehicule>()},
				{12, 6, new Case(5,11), new ArrayList<IVehicule>()},
				{16, 12, new Case(15,5), new ArrayList<IVehicule>()},
		};
		Case[][] cases = {
				{new Case(0,0), new Case(9,0), new Case(9,7), new Case(0, 7), new Case(-1,-1), new Case(0,-1), new Case(10,0), new Case(10,7), new Case(10, 8),new Case(0,8)},
				{new Case(0,0), new Case(7,0), new Case(7,9), new Case(0, 9), new Case(-1,-1), new Case(0,-1), new Case(8,0), new Case(8,9), new Case(8, 10),new Case(0,10)},
				{new Case(0,0), new Case(11,0), new Case(11,5), new Case(0, 5), new Case(-1,-1), new Case(0,-1), new Case(12,0), new Case(12,5), new Case(12, 6),new Case(0,6)},
				{new Case(0,0), new Case(15,0), new Case(15,11), new Case(0, 11), new Case(-1,-1), new Case(0,-1), new Case(16,0), new Case(16,11), new Case(16, 12),new Case(0,12)},
		};
		Object[] argg = new Object[1];
		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			Object pt2=null;
//			int resLargeur=0;
//			int resHauteur=0;
//			Case resCase=null;
//			List<IVehicule> resVehicules = null;
			//String resInscription="";
			List<IVehicule> l = new ArrayList<IVehicule>();
			try {
				pt1 = (c2.newInstance(ints[i]));
				l.add((IVehicule)pt1);
				pp[i][3]=l;
				pt2 = (c3.newInstance(pp[i]));
				fieldLargeur.set(pt2, pp[i][0]);
				fieldHauteur.set(pt2, pp[i][1]);
				fieldSortie.set(pt2, pp[i][2]);
				fieldVehicules.set(pt2, pp[i][3]);
				boolean contien = false;
				for (int jj=0; jj<cases[i].length; jj++) {
					argg[0]=cases[i][jj];
					contien=(boolean)mContient.invoke(pt2,argg );
					if (jj<4 && !contien) {
						System.out.println("   Aie... apres p = new Plateau( "+pp[i][0]+", "+pp[i][1]+", "+pp[i][2]+", "+pp[i][3]+") p.contient("+cases[i][jj]+" retourne false au lieu de true");
						return 0;
					}
					else if (jj>=4 && contien) {
						System.out.println("   Aie... apres p = new Plateau( "+pp[i][0]+", "+pp[i][1]+", "+pp[i][2]+", "+pp[i][3]+") p.contient("+cases[i][jj]+" retourne true au lieu de false");
						return 0;
					} 
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
/* 		if (!Reflexion.respecteDeveloppementEnCouche("src"+File.separator+"rushhour"+File.separator+"abstraction"+File.separator+"Plateau.java", cPlateau, "contient(")) {
			System.out.println("   Aie... la methode contient est un SERVICE : elle ne doit pas acceder directement aux variables d'instances afin de respecter le developpement en couches");
			return 50;
		}
*/

		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}






	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test08PlateauSolutionTrouvee() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cIPlateau = Reflexion.getClass("rushhour.abstraction.IPlateau");
		if (cIPlateau==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IPlateau dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.Vehicule");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe Vehicule. Impossible de tester");
			return 0;
		}
		Class cPlateau= Reflexion.getClass("rushhour.abstraction.Plateau");
		if (cPlateau==null) {
			System.out.println("   Aie... je ne trouve pas la classe Plateau. Impossible de tester");
			return 0;
		}

		Field fieldLongueur=null,  fieldCouleur=null, fieldOrientation=null, fieldCase=null, fieldInscription=null, fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLongueur==null && (f.getName().toLowerCase().contains("n")||f.getName().toLowerCase().contains("z")||fieldCouleur!=null)) {
						fieldLongueur=f;
					} else if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldOrientation==null && f.getType().equals(boolean.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldOrientation = f;
				} else if (fieldCase==null && f.getType().equals(Case.class)) {
					fieldCase=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}
		if (fieldLongueur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la longueur du vehicule.");
			return 0;
		}
		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldOrientation==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance booleenne correspondant a l'orientation du vehicule.");
			return 0;
		}
		if (fieldCase==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case la plus en haut a gauche du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=5) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 5 variables d'instance mentionnees dans l'enonce");
			return 0;
		}


		Field fieldLargeur=null,  fieldHauteur=null, fieldSortie=null, fieldVehicules=null;// fieldOther=null;
		Field[] tfp = cPlateau.getDeclaredFields();
		int nbvp=0;
		for (Field f : tfp) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbvp++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLargeur==null && (f.getName().toLowerCase().contains("la")||fieldHauteur!=null)) {
						fieldLargeur=f;
					} else if (fieldHauteur==null) {
						fieldHauteur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldSortie==null && f.getType().equals(Case.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldSortie = f;
				} else if (fieldVehicules==null &&( f.getType().equals(List.class)|| f.getType().equals(ArrayList.class)|| f.getType().equals(LinkedList.class))) {
					fieldVehicules=f;
				} else {
					System.out.println("typee="+f.getType()+"<<<");
					fieldOther = f;
				}
			}
		}
		if (fieldLargeur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la largeur du plateau.");
			return 0;
		}
		if (fieldHauteur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la hauteur du plateau.");
			return 0;
		}
		if (fieldSortie==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case de sortie du plateau.");
			return 0;
		}
		if (fieldVehicules==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type List<IVehicule> correspondant a la liste des vehicules du plateau.");
			return 0;
		}
		if (fieldOther!=null || nbvp!=4) {
			System.out.println("   Aie... Votre classe Plateau devrait comporter uniquement les 4 variables d'instance mentionnees dans l'enonce");
			return 0;
		}

		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe Vehicule n'implemente pas l'interface IVehicule.");
			return 0;
		}

		if (!Reflexion.implementsInterface(cPlateau, cIPlateau)) {
			System.out.println("   Aie... La classe Plateau n'implemente pas l'interface IPlateau.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldLargeur.getModifiers())
				|| !Modifier.isPrivate(fieldHauteur.getModifiers())
				|| !Modifier.isPrivate(fieldSortie.getModifiers())
				|| !Modifier.isPrivate(fieldVehicules.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Vehicule(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
		Class[] arg3 = { int.class, int.class, Case.class, List.class };
		Constructor c3=null;
		try {
			c3 = cPlateau.getDeclaredConstructor(arg3);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c3=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c3==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Plateau(int, int, Case, List<IVehicule>). Impossible de tester");
			return 0;
		}
		fieldLongueur.setAccessible(true);
		fieldOrientation.setAccessible(true);
		fieldCase.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		fieldLargeur.setAccessible(true);
		fieldHauteur.setAccessible(true);
		fieldSortie.setAccessible(true);
		fieldVehicules.setAccessible(true);
		//Method mGetLargeur=null;
		//Method mGetHauteur=null;
		//Method mGetSortie=null;
		//Method mGetVehicules=null;
		Method mSolutionTrouvee=null;

		Class[] ar = {};//Case.class};
		try {
			mSolutionTrouvee = cPlateau.getDeclaredMethod("solutionTrouvee", ar);
		} catch (NoSuchMethodException e1) {
			e1.printStackTrace();
		} catch (SecurityException e1) {
			e1.printStackTrace();
		}
		if (mSolutionTrouvee==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode solutionTrouvee() dans Plateau");
			return 0;
		}

		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(5,2), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,0), Integer.valueOf(96), new String("D")},
		};
		Object[][] pp = {
				{7, 7, new Case(0,0), new ArrayList<IVehicule>()},
				{8, 10, new Case(4,0), new ArrayList<IVehicule>()},
				{12, 6, new Case(5,11), new ArrayList<IVehicule>()},
				{16, 12, new Case(15,5), new ArrayList<IVehicule>()},
		};
//		Case[][] cases = {
//				{new Case(0,0), new Case(9,0), new Case(9,7), new Case(0, 7), new Case(-1,-1), new Case(0,-1), new Case(10,0), new Case(10,7), new Case(10, 8),new Case(0,8)},
//				{new Case(0,0), new Case(7,0), new Case(7,9), new Case(0, 9), new Case(-1,-1), new Case(0,-1), new Case(8,0), new Case(8,9), new Case(8, 10),new Case(0,10)},
//				{new Case(0,0), new Case(11,0), new Case(11,5), new Case(0, 5), new Case(-1,-1), new Case(0,-1), new Case(12,0), new Case(12,5), new Case(12, 6),new Case(0,6)},
//				{new Case(0,0), new Case(15,0), new Case(15,11), new Case(0, 11), new Case(-1,-1), new Case(0,-1), new Case(16,0), new Case(16,11), new Case(16, 12),new Case(0,12)},
//		};
		Object[] argg = {};//new Object[1];
		List<IVehicule> vehicules = new ArrayList<IVehicule>();
		//  String stringVehicules = "{";
		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			try {
				pt1 = (c2.newInstance(ints[i]));
				fieldCase.set(pt1, ints[i][2]);
				fieldLongueur.set(pt1, ints[i][0]);
				fieldOrientation.set(pt1,  ints[i][1]);
				fieldCouleur.set(pt1,  ints[i][3]);
				vehicules.add((IVehicule)pt1);
				//	stringVehicules+="vehicule(lg="+(int)(ints[i][0])+" hg="+(Case)(ints[i][2])+"")
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		for (int c=0; c<7; c++) {
			for (int l=0; l<7; l++) {	

//				Object pt1=null;
				Object pt2=null;
//				int resLargeur=0;
//				int resHauteur=0;
//				Case resCase=null;
//				List<IVehicule> resVehicules = null;
				boolean solTrouvee=false;
				try {
					pp[0][2]= new Case(c,l);
					pp[0][3]=vehicules;//l;
					pt2 = (c3.newInstance(pp[0]));
					fieldLargeur.set(pt2, pp[0][0]);
					fieldHauteur.set(pt2, pp[0][1]);
					fieldSortie.set(pt2, pp[0][2]);
					fieldVehicules.set(pt2, pp[0][3]);

					solTrouvee=(boolean)mSolutionTrouvee.invoke(pt2,argg );
					if (((c==5 && l==2)||(c==6&&l==2))&& !solTrouvee) {
						System.out.println("   Aie... apres p = new Plateau( "+pp[0][0]+", "+pp[0][1]+", "+pp[0][2]+", {...}) avec la voiture rouge occupant les cases (5,2) et (6,2) p.solutionTrouvee() retourne false au lieu de true");
						return 0;
					}
					else if (!((c==5 && l==2)||(c==6&&l==2))&& solTrouvee) {
						System.out.println("   Aie... apres p = new Plateau( "+pp[0][0]+", "+pp[0][1]+", "+pp[0][2]+", {...}) avec la voiture rouge occupant les cases (5,2) et (6,2) p.solutionTrouvee() retourne true au lieu de false");
						return 0;
					} 
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
		/*
		if (!Reflexion.respecteDeveloppementEnCouche("src"+File.separator+"rushhour"+File.separator+"abstraction"+File.separator+"Plateau.java", cPlateau, "solutionTrouvee(")) {
			System.out.println("   Aie... la methode solutionTrouvee est un SERVICE : elle ne doit pas acceder directement aux variables d'instances afin de respecter le developpement en couches");
			return 50;
		}
        */
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}





	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test09PlateauVehiculeEn() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cIPlateau = Reflexion.getClass("rushhour.abstraction.IPlateau");
		if (cIPlateau==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IPlateau dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.Vehicule");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe Vehicule. Impossible de tester");
			return 0;
		}
		Class cPlateau= Reflexion.getClass("rushhour.abstraction.Plateau");
		if (cPlateau==null) {
			System.out.println("   Aie... je ne trouve pas la classe Plateau. Impossible de tester");
			return 0;
		}

		Field fieldLongueur=null,  fieldCouleur=null, fieldOrientation=null, fieldCase=null, fieldInscription=null, fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLongueur==null && (f.getName().toLowerCase().contains("n")||f.getName().toLowerCase().contains("z")||fieldCouleur!=null)) {
						fieldLongueur=f;
					} else if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldOrientation==null && f.getType().equals(boolean.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldOrientation = f;
				} else if (fieldCase==null && f.getType().equals(Case.class)) {
					fieldCase=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}
		if (fieldLongueur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la longueur du vehicule.");
			return 0;
		}
		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldOrientation==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance booleenne correspondant a l'orientation du vehicule.");
			return 0;
		}
		if (fieldCase==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case la plus en haut a gauche du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=5) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 5 variables d'instance mentionnees dans l'enonce");
			return 0;
		}


		Field fieldLargeur=null,  fieldHauteur=null, fieldSortie=null, fieldVehicules=null;// fieldOther=null;
		Field[] tfp = cPlateau.getDeclaredFields();
		int nbvp=0;
		for (Field f : tfp) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbvp++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldLargeur==null && (f.getName().toLowerCase().contains("la")||fieldHauteur!=null)) {
						fieldLargeur=f;
					} else if (fieldHauteur==null) {
						fieldHauteur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldSortie==null && f.getType().equals(Case.class)) {//!Modifier.isFinal(f.getModifiers())) {
					fieldSortie = f;
				} else if (fieldVehicules==null &&( f.getType().equals(List.class)|| f.getType().equals(ArrayList.class)|| f.getType().equals(LinkedList.class))) {
					fieldVehicules=f;
				} else {
					System.out.println("typee="+f.getType()+"<<<");
					fieldOther = f;
				}
			}
		}
		if (fieldLargeur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la largeur du plateau.");
			return 0;
		}
		if (fieldHauteur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la hauteur du plateau.");
			return 0;
		}
		if (fieldSortie==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type Case correspondant a la case de sortie du plateau.");
			return 0;
		}
		if (fieldVehicules==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type List<IVehicule> correspondant a la liste des vehicules du plateau.");
			return 0;
		}
		if (fieldOther!=null || nbvp!=4) {
			System.out.println("   Aie... Votre classe Plateau devrait comporter uniquement les 4 variables d'instance mentionnees dans l'enonce");
			return 0;
		}

		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe Vehicule n'implemente pas l'interface IVehicule.");
			return 0;
		}

		if (!Reflexion.implementsInterface(cPlateau, cIPlateau)) {
			System.out.println("   Aie... La classe Plateau n'implemente pas l'interface IPlateau.");
			return 0;
		}
		if (!Modifier.isPrivate(fieldLargeur.getModifiers())
				|| !Modifier.isPrivate(fieldHauteur.getModifiers())
				|| !Modifier.isPrivate(fieldSortie.getModifiers())
				|| !Modifier.isPrivate(fieldVehicules.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Vehicule(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
		Class[] arg3 = { int.class, int.class, Case.class, List.class };
		Constructor c3=null;
		try {
			c3 = cPlateau.getDeclaredConstructor(arg3);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c3=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c3==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur Plateau(int, int, Case, List<IVehicule>). Impossible de tester");
			return 0;
		}
		fieldLongueur.setAccessible(true);
		fieldOrientation.setAccessible(true);
		fieldCase.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		fieldLargeur.setAccessible(true);
		fieldHauteur.setAccessible(true);
		fieldSortie.setAccessible(true);
		fieldVehicules.setAccessible(true);
		Method mVehiculeEn=null;

		Class[] ar = {Case.class};
		try {
			mVehiculeEn = cPlateau.getDeclaredMethod("vehiculeEn", ar);
		} catch (NoSuchMethodException e1) {
			e1.printStackTrace();
		} catch (SecurityException e1) {
			e1.printStackTrace();
		}
		if (mVehiculeEn==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode vehiculeEn() dans Plateau");
			return 0;
		}

		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(5,2), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,0), Integer.valueOf(96), new String("D")},
		};
		Object[][] pp = {
				{7, 7, new Case(0,0), new ArrayList<IVehicule>()},
				{8, 10, new Case(4,0), new ArrayList<IVehicule>()},
				{12, 6, new Case(5,11), new ArrayList<IVehicule>()},
				{16, 12, new Case(15,5), new ArrayList<IVehicule>()},
		};
//		Case[][] cases = {
//				{new Case(0,0), new Case(9,0), new Case(9,7), new Case(0, 7), new Case(-1,-1), new Case(0,-1), new Case(10,0), new Case(10,7), new Case(10, 8),new Case(0,8)},
//				{new Case(0,0), new Case(7,0), new Case(7,9), new Case(0, 9), new Case(-1,-1), new Case(0,-1), new Case(8,0), new Case(8,9), new Case(8, 10),new Case(0,10)},
//				{new Case(0,0), new Case(11,0), new Case(11,5), new Case(0, 5), new Case(-1,-1), new Case(0,-1), new Case(12,0), new Case(12,5), new Case(12, 6),new Case(0,6)},
//				{new Case(0,0), new Case(15,0), new Case(15,11), new Case(0, 11), new Case(-1,-1), new Case(0,-1), new Case(16,0), new Case(16,11), new Case(16, 12),new Case(0,12)},
//		};
		Object[] argg = new Object[1];
		List<IVehicule> vehicules = new ArrayList<IVehicule>();
		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			try {
				pt1 = (c2.newInstance(ints[i]));
				fieldCase.set(pt1, ints[i][2]);
				fieldLongueur.set(pt1, ints[i][0]);
				fieldOrientation.set(pt1,  ints[i][1]);
				fieldCouleur.set(pt1,  ints[i][3]);
				vehicules.add((IVehicule)pt1);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		int[][]indexs = {
				{-1, -1, -1, -1, -1, -1, -1}, 
				{-1, -1, -1, 2, 2, -1, -1}, 
				{-1, -1, -1, -1, 1, -1, -1}, 
				{3, 3, 3, -1, 1, -1, -1}, 
				{-1, -1, -1, -1, 1, -1, -1}, 
				{-1, -1, 0, -1, -1, -1, -1}, 
				{-1, -1, 0, -1, -1, -1, -1},	
		};
		for (int c=0; c<7; c++) {
			for (int l=0; l<7; l++) {	

//				Object pt1=null;
				Object pt2=null;
//				int resLargeur=0;
//				int resHauteur=0;
//				Case resCase=null;
//				List<IVehicule> resVehicules = null;
//				boolean solTrouvee=false;
				IVehicule res=null;
				try {
					pp[0][2]= new Case(c,l);
					pp[0][3]=vehicules;//l;
					pt2 = (c3.newInstance(pp[0]));
					fieldLargeur.set(pt2, pp[0][0]);
					fieldHauteur.set(pt2, pp[0][1]);
					fieldSortie.set(pt2, pp[0][2]);
					fieldVehicules.set(pt2, pp[0][3]);

					argg[0]=new Case(c,l);
					res = (IVehicule)mVehiculeEn.invoke(pt2, argg);
					if (indexs[c][l]!=vehicules.indexOf(res)) {
						System.out.println("   Aie... sur un plateau ayant pour liste de vehicules : ");
						for (int i=0; i<vehicules.size(); i++) {
							System.out.print(i+" -> vehicule occupant les cases : ");
							for (Case ca : vehicules.get(i).getCases()) {
								System.out.print(ca+", ");
							}
							System.out.println("");
						}
						if (res==null) {// || vehicules.indexOf(res)<0) {
							System.out.println("   vehiculeEn(("+c+", "+l+")) retourne null au lieu du vehicule d'index "+indexs[c][l]);
						} else {
							System.out.println("   vehiculeEn(("+c+", "+l+")) retourne "+vehicules.indexOf(res)+" au lieu du vehicule d'index "+indexs[c][l]);
						}
						return 0;
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
//		if (!Reflexion.respecteDeveloppementEnCouche("src"+File.separator+"rushhour"+File.separator+"abstraction"+File.separator+"Plateau.java", cPlateau, "vehiculeEn(")) {
//			System.out.println("   Aie... la methode vehiculeEn est un SERVICE : elle ne doit pas acceder directement aux variables d'instances afin de respecter le developpement en couches");
//			return 50;
//		}

		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test10VehiculeCasesConstructeur() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.VehiculeCases");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe VehiculeCases. Impossible de tester");
			return 0;
		}

		Field //fieldLongueur=null,  
				fieldCouleur=null,
				//fieldOrientation=null, 
				//fieldCase=null, 
				fieldInscription=null, 
				fieldCases=null, 
				fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldCases==null && f.getType().equals(List.class)) {
					fieldCases=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}

		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldCases==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance correspondant a la liste des cases du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=3) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 3 variables d'instance mentionnees dans l'enonce");
			return 0;
		}
		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe VehiculeCases n'implemente pas l'interface IVehicule.");
			return 0;
		}
		if ( !Modifier.isPrivate(fieldCouleur.getModifiers())
				|| !Modifier.isPrivate(fieldCases.getModifiers())
				|| !Modifier.isPrivate(fieldInscription.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur VehiculeCases(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
	//	fieldLongueur.setAccessible(true);
	//	fieldOrientation.setAccessible(true);
		fieldCases.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(0,0), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,2), Integer.valueOf(96), new String("D")},
		};
		List<Case> r1 = new ArrayList<Case>();
		r1.add(new Case(0,0));
		r1.add(new Case(1,0));
		List<Case> r2 = new ArrayList<Case>();
		r2.add(new Case(2,4));
		r2.add(new Case(3,4));
		r2.add(new Case(4,4));
		List<Case> r3 = new ArrayList<Case>();
		r3.add(new Case(1,3));
		r3.add(new Case(1,4));
		List<Case> r4 = new ArrayList<Case>();
		r4.add(new Case(3,2));
		r4.add(new Case(3,3));
		r4.add(new Case(3,4));

		List<Case>[] tRes = new List[4];
		tRes[0]=r1;
		tRes[1]=r2;
		tRes[2]=r3;
		tRes[3]=r4;
		
		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			//int resLongueur=0;
			//boolean resOrientation=false;
			List<Case> resCases=null;
			int resCouleur = 0;
			String resInscription="";
			try {
				pt1 = (c2.newInstance(ints[i]));
			//	resLongueur = (int)(fieldLongueur.get(pt1));
			//	resOrientation = (boolean)(fieldOrientation.get(pt1));
				resCases = (List<Case>)(fieldCases.get(pt1));
				resCouleur = (int)(fieldCouleur.get(pt1));
				resInscription = (String)(fieldInscription.get(pt1));
			} catch (Exception e) {
				e.printStackTrace();
			}
//			if (resLongueur!=(int)(ints[i][0])) {
//				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v a pour longueur "+resLongueur+".\n");
//				return 0;
//			}
//			if (resOrientation!=(boolean)(ints[i][1])) {
//				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v a pour orientation "+resOrientation+".\n");
//				return 0;
//			}
			if (resCases==null) {
				System.out.println("   Aie... votre constructeur initialise a null la variable "+fieldCases.getName());
				return 0;
			}
			if (!resCases.equals(tRes[i])) {//!=(Case)(ints[i][2])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v a pour liste de cases "+resCases+".\n");
				return 0;
			}
			if (resCouleur!=(int)(ints[i][3])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v a pour couleur "+resCouleur+".\n");
				return 0;
			}
			if (!resInscription.equals((String)(ints[i][4]))) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v a pour inscription "+resInscription+".\n");
				return 0;
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}



	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test11VehiculeCasesAccesseurs() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.VehiculeCases");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe VehiculeCases. Impossible de tester");
			return 0;
		}

		Field //fieldLongueur=null,  
				fieldCouleur=null,
				//fieldOrientation=null, 
				//fieldCase=null, 
				fieldInscription=null, 
				fieldCases=null, 
				fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldCases==null && f.getType().equals(List.class)) {
					fieldCases=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}

		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldCases==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance correspondant a la liste des cases du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=3) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 3 variables d'instance mentionnees dans l'enonce");
			return 0;
		}
		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe VehiculeCases n'implemente pas l'interface IVehicule.");
			return 0;
		}
		if ( !Modifier.isPrivate(fieldCouleur.getModifiers())
				|| !Modifier.isPrivate(fieldCases.getModifiers())
				|| !Modifier.isPrivate(fieldInscription.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur VehiculeCases(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
	//	fieldLongueur.setAccessible(true);
	//	fieldOrientation.setAccessible(true);
		fieldCases.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		Method mGetLongueur=null;
		Method mGetOrientation=null;
		//Method mGetHautGauche=null;
		Method mGetCases=null;
		Method mGetCouleur=null;
		Method mGetInscription=null;
		Class[] ar = {};
		try {
			mGetLongueur = cVehicule.getDeclaredMethod("getLongueur", ar);
			mGetOrientation = cVehicule.getDeclaredMethod("getOrientation", ar);
			//	mGetHautGauche = cVehicule.getDeclaredMethod("getHautGauche", ar);
			mGetCases = cVehicule.getDeclaredMethod("getCases", ar);
			mGetCouleur = cVehicule.getDeclaredMethod("getCouleur", ar);
			mGetInscription = cVehicule.getDeclaredMethod("getInscription", ar);
		} catch (NoSuchMethodException e1) {
			e1.printStackTrace();
		} catch (SecurityException e1) {
			e1.printStackTrace();
		}
		if (mGetLongueur==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getLongueur() dans Vehicule");
			return 0;
		}
		if (mGetOrientation==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getOrientation() dans Vehicule");
			return 0;
		}

		if (mGetCases==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getCases() dans Vehicule");
			return 0;
		}
		if (mGetCouleur==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getCouleur() dans Vehicule");
			return 0;
		}
		if (mGetInscription==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode getInscription() dans Vehicule");
			return 0;
		}

		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(0,0), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,2), Integer.valueOf(96), new String("D")},
		};
		Case[][] cases = {
				{new Case(0,0), new Case(1,0)},
				{new Case(2,4), new Case(3,4), new Case(4,4)},
				{new Case(1,3), new Case(1,4)},
				{new Case(3,2), new Case(3,3), new Case(3,4)}
		};
		List<Case>[] tlc = new List[4];
		for (int i=0; i<4; i++) {
			tlc[i]=Arrays.asList(cases[i]);
		}
		Object[] arg = {};
		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			int resLongueur=0;
			boolean resOrientation=false;
			//Case resCase=null;
			List<Case> resCases=null;
			int resCouleur = 0;
			String resInscription="";
			try {
				pt1 = (c2.newInstance(ints[i]));
			//	fieldLongueur.set(pt1,  ints[i][0]);
			//	fieldOrientation.set(pt1,  ints[i][1]);
				fieldCases.set(pt1,  tlc[i]);//ints[i][2]);
				fieldCouleur.set(pt1,  ints[i][3]);
				fieldInscription.set(pt1,  ints[i][4]);
				resLongueur = (int)(mGetLongueur.invoke(pt1,  arg));
				resOrientation = (boolean)(mGetOrientation.invoke(pt1,  arg));
				//		resCase = (Case)(mGetHautGauche.invoke(pt1,  arg));
				resCouleur = (int)(mGetCouleur.invoke(pt1,  arg));
				resInscription = (String)(mGetInscription.invoke(pt1,  arg));
				resCases = (List<Case>)(mGetCases.invoke(pt1, arg));
			} catch (Exception e) {
				e.printStackTrace();
			}
			if (resLongueur!=(int)(ints[i][0])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v.getLongueur() retourne "+resLongueur+".\n");
				return 0;
			}
			if (resOrientation!=(boolean)(ints[i][1])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v.getOrientation() "+resOrientation+".\n");
				return 0;
			}
			/*	if (resCase!=(Case)(ints[i][2])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v.getHautGauche() retourne "+resCase+".\n");
				return 0;
			}*/
			if (resCouleur!=(int)(ints[i][3])) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v.getCouleur() retourne "+resCouleur+".\n");
				return 0;
			}
			if (!resInscription.equals((String)(ints[i][4]))) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v.getInscription() retourne "+resInscription+".\n");
				return 0;
			}
			if (!resCases.equals(Arrays.asList(cases[i]))) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") v.getCases() retourne "+resCases+" au lieu de "+Arrays.asList(cases[i]));
				return 0;
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}


	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test12VehiculeDeplacerEn() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.VehiculeCases");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe VehiculeCases. Impossible de tester");
			return 0;
		}

		Field //fieldLongueur=null,  
				fieldCouleur=null,
				//fieldOrientation=null, 
				//fieldCase=null, 
				fieldInscription=null, 
				fieldCases=null, 
				fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldCases==null && f.getType().equals(List.class)) {
					fieldCases=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}

		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldCases==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance correspondant a la liste des cases du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=3) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 3 variables d'instance mentionnees dans l'enonce");
			return 0;
		}
		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe VehiculeCases n'implemente pas l'interface IVehicule.");
			return 0;
		}
		if ( !Modifier.isPrivate(fieldCouleur.getModifiers())
				|| !Modifier.isPrivate(fieldCases.getModifiers())
				|| !Modifier.isPrivate(fieldInscription.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur VehiculeCases(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
	//	fieldLongueur.setAccessible(true);
	//	fieldOrientation.setAccessible(true);
		fieldCases.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		Method mDeplacerEn=null;
		Class[] ar = {Case.class};
		try {
			mDeplacerEn = cVehicule.getDeclaredMethod("deplacerEn", ar);
		} catch (NoSuchMethodException e1) {
			e1.printStackTrace();
		} catch (SecurityException e1) {
			e1.printStackTrace();
		}
		if (mDeplacerEn==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode deplacerEn(Case) dans Vehicule");
			return 0;
		}

		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(0,0), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,2), Integer.valueOf(96), new String("D")},
		};
		Case[][] cases = {
				{new Case(2,0)},
				{new Case(0,4)},
				{new Case(1,1)},
				{new Case(3,3)}
		};
		Case[][] casesRes = {
				{new Case(2,0), new Case(3,0)},
				{new Case(0,4), new Case(1,4), new Case(2,4)},
				{new Case(1,1), new Case(1,2)},
				{new Case(3,3), new Case(3,4), new Case(3,5)}
		};
		List<Case>[] tlcRes = new List[4];
		for (int i=0; i<4; i++) {
			tlcRes[i]=Arrays.asList(casesRes[i]);
		}
		Case[][] casess = {
				{new Case(0,0), new Case(1,0)},
				{new Case(2,4), new Case(3,4), new Case(4,4)},
				{new Case(1,3), new Case(1,4)},
				{new Case(3,2), new Case(3,3), new Case(3,4)}
		};
		List<Case>[] tlc = new List[4];
		for (int i=0; i<4; i++) {
			tlc[i]=Arrays.asList(casess[i]);
		}

		Object[] arg = new Object[1];

		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			//int resLongueur=0;
			//boolean resOrientation=false;
			List<Case> resCase=null;
			//List<Case> resCases=null;
			//int resCouleur = 0;
			//String resInscription="";
			try {
				pt1 = (c2.newInstance(ints[i]));
			//	fieldLongueur.set(pt1,  ints[i][0]);
			//	fieldOrientation.set(pt1,  ints[i][1]);
				fieldCases.set(pt1,  tlc[i]);//ints[i][2]);
				fieldCouleur.set(pt1,  ints[i][3]);
				fieldInscription.set(pt1,  ints[i][4]);
				arg[0]=cases[i][0];
				mDeplacerEn.invoke(pt1,  arg);
				resCase=(List<Case>)(fieldCases.get(pt1)); 
			} catch (Exception e) {
				e.printStackTrace();
			}
			if (!resCase.equals(tlcRes[i])) {//cases[i][0]) {//) {
				System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+") et v.deplaceEn("+cases[i][0]+") la liste des cases du vehicule est "+resCase+" au lieu de "+tlcRes[i]);//case haut gauche du vehicule est "+resCase+".\n");
				return 0;
			} 
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}





	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static int test13VehiculeOccupe() {
		Class cIVehicule = Reflexion.getClass("rushhour.abstraction.IVehicule");
		if (cIVehicule==null) {
			System.out.println("   Aie... je ne trouve pas l'interface IVehicule dans le package abstraction");
			System.out.println("          vous avez vraisemblablement deplace/supprime le fichier de cette interface");
			return 0;
		}	
		Class cVehicule= Reflexion.getClass("rushhour.abstraction.VehiculeCases");
		if (cVehicule==null) {
			System.out.println("   Aie... je ne trouve pas la classe VehiculeCases. Impossible de tester");
			return 0;
		}

		Field //fieldLongueur=null,  
				fieldCouleur=null,
				//fieldOrientation=null, 
				//fieldCase=null, 
				fieldInscription=null, 
				fieldCases=null, 
				fieldOther=null;
		Field[] tf = cVehicule.getDeclaredFields();
		int nbv=0;
		for (Field f : tf) {
			if (!Modifier.isStatic(f.getModifiers())) {//isFinal(f.getModifiers())) {
				nbv++;

				if ( f.getType().equals(int.class)) {// && !Modifier.isFinal(f.getModifiers())) {
					if (fieldCouleur==null) {
						fieldCouleur=f;
					}else { 
						fieldOther=f;
					}
				} else if (fieldCases==null && f.getType().equals(List.class)) {
					fieldCases=f;
				} else if (fieldInscription==null && f.getType().equals(String.class)) {
					fieldInscription=f;
				} else {
					fieldOther = f;
				}
			}
		}

		if (fieldCouleur==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance entiere correspondant a la couleur du vehicule.");
			return 0;
		}
		if (fieldCases==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance correspondant a la liste des cases du vehicule.");
			return 0;
		}
		if (fieldInscription==null) {
			System.out.println("   Aie... Je ne trouve pas la variable d'instance de type String correspondant a l'inscription sur le vehicule.");
			return 0;
		}
		if (fieldOther!=null || nbv!=3) {
			System.out.println("   Aie... Votre classe Vehicule devrait comporter uniquement les 3 variables d'instance mentionnees dans l'enonce");
			return 0;
		}
		if (!Reflexion.implementsInterface(cVehicule, cIVehicule)) {
			System.out.println("   Aie... La classe VehiculeCases n'implemente pas l'interface IVehicule.");
			return 0;
		}
		if ( !Modifier.isPrivate(fieldCouleur.getModifiers())
				|| !Modifier.isPrivate(fieldCases.getModifiers())
				|| !Modifier.isPrivate(fieldInscription.getModifiers())
				) {
			System.out.println("   Aie... pour respecter le principe d'encapsulation vos variables d'instance devraient etre declarees private");
			return 0;
		}
		Class[] arg2 = { int.class, boolean.class, Case.class, int.class, String.class };
		Constructor c2=null;
		try {
			c2 = cVehicule.getDeclaredConstructor(arg2);
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			c2=null;
		} catch (SecurityException e) {
			e.printStackTrace();
		}
		if (c2==null) {
			System.out.println("   Aie... je ne trouve pas le constructeur VehiculeCases(int, boolean, Case, int, String). Impossible de tester");
			return 0;
		}
	//	fieldLongueur.setAccessible(true);
	//	fieldOrientation.setAccessible(true);
		fieldCases.setAccessible(true);
		fieldCouleur.setAccessible(true);
		fieldInscription.setAccessible(true);
		Method mOccupe=null;
		Class[] ar = {Case.class};
		try {
			mOccupe = cVehicule.getDeclaredMethod("occupe", ar);
		} catch (NoSuchMethodException e1) {
			e1.printStackTrace();
		} catch (SecurityException e1) {
			e1.printStackTrace();
		}
		if (mOccupe==null) {
			System.out.println("   Aie... vous n'avez pas defini la methode occupe(Case) dans Vehicule");
			return 0;
		}

		Object[][] ints = {
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(0,0), Integer.valueOf(12), new String("A")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.HORIZONTALE), new Case(2,4), Integer.valueOf(24), new String("B")},
				{Integer.valueOf(2), Boolean.valueOf(IVehicule.VERTICALE), new Case(1,3), Integer.valueOf(48), new String("C")},
				{Integer.valueOf(3), Boolean.valueOf(IVehicule.VERTICALE), new Case(3,2), Integer.valueOf(96), new String("D")},
		};
		List<Case> r1 = new ArrayList<Case>();
		r1.add(new Case(0,0));
		r1.add(new Case(1,0));
		List<Case> r2 = new ArrayList<Case>();
		r2.add(new Case(2,4));
		r2.add(new Case(3,4));
		r2.add(new Case(4,4));
		List<Case> r3 = new ArrayList<Case>();
		r3.add(new Case(1,3));
		r3.add(new Case(1,4));
		List<Case> r4 = new ArrayList<Case>();
		r4.add(new Case(3,2));
		r4.add(new Case(3,3));
		r4.add(new Case(3,4));

		List<Case>[] tRes = new List[4];
		tRes[0]=r1;
		tRes[1]=r2;
		tRes[2]=r3;
		tRes[3]=r4;
		

		Case[][] cases = {
				{new Case(0,0), new Case(1,0), new Case(0,1), new Case(1,1)},
				{new Case(2,4), new Case(3,4), new Case(4,4), new Case(1,4), new Case(2,3), new Case(2,5), new Case(5,4), new Case(4,3), new Case(4,5)},
				{new Case(1,3), new Case(1,4), new Case(1,2), new Case(0,3), new Case(2,3), new Case(1,5), new Case(0,4), new Case(2,2)},
				{new Case(3,2), new Case(3,3), new Case(3,4), new Case(3,1), new Case(2,2), new Case(4,2), new Case(3,5), new Case(2,4), new Case(4,4)}
		};
		boolean[][] res = {
				{true, true, false, false},
				{true, true, true, false, false, false, false, false, false},
				{true, true, false, false, false, false, false, false},
				{true, true, true, false, false, false, false, false, false}
		};
		Object[] arg = new Object[1];

		for (int i=0; i<ints.length; i++) {
			Object pt1=null;
			//int resLongueur=0;
			//boolean resOrientation=false;
//			Case resCase=null;
//			List<Case> resCases=null;
//			int resCouleur = 0;
//			String resInscription="";
			boolean resOccupe=false;
			try {
				pt1 = (c2.newInstance(ints[i]));
			//	fieldLongueur.set(pt1,  ints[i][0]);
			//	fieldOrientation.set(pt1,  ints[i][1]);
				fieldCases.set(pt1,  tRes[i]);//ints[i][2]);
				fieldCouleur.set(pt1,  ints[i][3]);
				fieldInscription.set(pt1,  ints[i][4]);
				for (int jj=0; jj<cases[i].length; jj++) {
					arg[0]=cases[i][jj];
					resOccupe = (boolean)(mOccupe.invoke(pt1,  arg));
					if (resOccupe!=res[i][jj]) {
						System.out.println("   Aie... apres v = new Vehicule( "+ints[i][0]+", "+ints[i][1]+", "+ints[i][2]+", "+ints[i][3]+", "+ints[i][4]+")  v.occupe("+cases[i][jj]+") retourne "+resOccupe+".\n");
						return 0;
					} 
				}
			//	resCase=(Case)(fieldCase.get(pt1)); 
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		System.out.println(" OK, votre implementation passe le test.");
		return 100;
	}







}

